#include "patch.h"

RGBQUAD pal[256];
int lookup[256];

void FreeCvtResources()
{
	FreeResourceDefinition(&ResDef);
}


int cvtmain(int argc,char **argv)
{
	int i,k,fcnt;
	int RC,GC,BC;
	char dd[256];
	Bitmap out;

	dprintf(logfile,"\n");

	CopyEnvironmentCLArgs("CVT",argc,argv);
	if (ParseCommandLine(-1,-1))
	{
		FreeCLStrs();
		return 3;
	}

	if (!nclfiles)
	{
		dprintf(logfile,"\nCVT.EXE %s by Jim Flynn, Copyright 1997 -- Freeware --\n",PATCHER_VERSION);
		dprintf(logfile,"\nChange a collection of .BMPs to another palette\n");
		dprintf(logfile,"\nUsage: CVT [options] name[.BMP]...\n");
		dprintf(logfile,"name may contain DOS wildcards\n");
		dprintf(logfile,"\nGeneral options, use SET CVT=options to set defaults:\n");
		dprintf(logfile," /DOOM2 /DOOM /HERETIC /HEXEN specify game palette\n");
		dprintf(logfile," /I:name specify wad containing PLAYPAL for palette\n");
		dprintf(logfile," /D:name[.DEF] specify resource definition palette\n");
		dprintf(logfile," /R:weight integer weight for red in palette match\n");
		dprintf(logfile," /G:weight integer weight for green in palette match\n");
		dprintf(logfile," /B:weight integer weight for blue in palette match\n");
		dprintf(logfile,"\n See CVT.TXT for details.\n");

		FreeCLStrs();
		return(1);
	}

	RC=GC=BC=1;
	for (i=0;i<nclopts;i++)
	{
		if (stricmp(cloptions[i],"DOOM")==0 || stricmp(cloptions[i],"DOOM2")==0 ||
			     stricmp(cloptions[i],"HERETIC")==0 || stricmp(cloptions[i],"HEXEN")==0)
			strcpy(defname,cloptions[i]);
		else if (tolower(cloptions[i][0])=='d' && cloptions[i][1]==':')
			strcpy(defname,cloptions[i]+2);
		else if (tolower(cloptions[i][0])=='i' && cloptions[i][1]==':')
			strcpy(iwadname,cloptions[i]+2);
		else if (tolower(cloptions[i][0])=='r' && cloptions[i][1]==':')
			RC = atoi(cloptions[i]+2);
		else if (tolower(cloptions[i][0])=='g' && cloptions[i][1]==':')
			GC = atoi(cloptions[i]+2);
		else if (tolower(cloptions[i][0])=='b' && cloptions[i][1]==':')
			BC = atoi(cloptions[i]+2);
		else dprintf(logfile,"Warn: Command line option %s not understood\n",cloptions[i]);
	}
	setweights(RC,GC,BC);

	AddExt(iwadname,".WAD");
	AddExt(defname,".DEF");
	InitCategories(defname,&ResDef);

	if (*iwadname)						// then the IWAD, if spec'd
	{
		FILE *ist;
		WadHeader ihdr;
		WadDir idir;
		int n;

		InitDir(&idir);
		ist = fopen(iwadname,"rb");
		if (ist!=NULL)
		{
			dprintf(logfile,"Using PLAYPAL from IWAD %s for palette\n",iwadname);
			fread(&ihdr,sizeof(WadHeader),1,ist);
			ReadDir(&ihdr,&idir,ist);
			n = IsIn("PLAYPAL",&idir);
			if (n>=0)
				palette = GetPalette(&idir,ist,n);
			fclose(ist);
			FreeDir(&idir);
		}
	}
	else palette = GetPalette(NULL,NULL,-1);

	fcnt=0;
	for (k=0;k<nclfiles;k++)
	{
		struct _find_t ff;
		clfiles[k] = (char *)realloc(clfiles[k],strlen(clfiles[k])+1+4);
		AddExt(clfiles[k],".BMP");

		if (!_dos_findfirst(clfiles[k],_A_NORMAL,&ff))
		{
			do
			{
				fcnt++;
				sprintf(dd,"%s",DriveDirOf(clfiles[k]));
				if (strlen(dd)) strcat(dd,"\\");
				ReadBMP(&out,stringf("%s%s",dd,ff.name),pal);
				ConvertBMP(&out,pal,palette); 
				WriteBMP(&out,stringf("%s%s",dd,ff.name),palette);
				free(out.bmp);
				out.bmp=NULL;
			}
			while (!_dos_findnext(&ff));
		}

	}
	dprintf(logfile,"%d .BMP's were converted to palette\n",fcnt);
	dprintf(logfile,"\n");

	return 0;
}


