#include "patch.h"
#include <crt0.h>

static int *DoMap;
static char *txtures=NULL;
static char *wilds=NULL;
static int *txttotcnt=NULL;
static int *txtcelcnt=NULL;
static int *txtflrcnt=NULL;
static int *alltotcnt=NULL;
static int *allcelcnt=NULL;
static int *allflrcnt=NULL;
static int ntxtures=0;
static int nwilds=0;
static int detailhdrdone=0;

static int DoDetails=1;
static int DoSummary=1;
static int DoTotals=1;
static int DoBlanks=0;
static int ResolveTextures=0;
static int UseInternalTextures=0;
static int DoAnimated=0;
static int DoSingles=0;

static void InitMapHist()
{
	memset(txttotcnt,0,2048*sizeof(int));
	memset(txtcelcnt,0,2048*sizeof(int));
	memset(txtflrcnt,0,2048*sizeof(int));
}

void InitFlatHist()
{
	DoMap = NULL;
	txtures = NULL;
	wilds = NULL;
	txttotcnt = NULL;
	txtcelcnt = NULL;
	txtflrcnt = NULL;
	alltotcnt = NULL;
	allcelcnt = NULL;
	allflrcnt = NULL;
	detailhdrdone=0;
	ntxtures=0;
	nwilds=0;
}

static void AllocHist()
{
	DoMap = (int *)malloc(100*sizeof(int));
	txtures = (char *)malloc(16392*sizeof(char));
	wilds = (char *)malloc(1032*sizeof(char));
	txttotcnt = (int *)malloc(2048*sizeof(int));
	txtcelcnt = (int *)malloc(2048*sizeof(int));
	txtflrcnt = (int *)malloc(2048*sizeof(int));
	alltotcnt = (int *)malloc(2048*sizeof(int));
	allcelcnt = (int *)malloc(2048*sizeof(int));
	allflrcnt = (int *)malloc(2048*sizeof(int));

	memset(txtures,0,16384);
	memset(wilds,0,1024);
	memset(alltotcnt,0,2048*sizeof(int));
	memset(allcelcnt,0,2048*sizeof(int));
	memset(allflrcnt,0,2048*sizeof(int));
	detailhdrdone=0;
	ntxtures=0;
	nwilds=0;
}

void FreeFlatHist()
{
	free(DoMap);
	DoMap = NULL;
	free(txtures);
	txtures = NULL;
	free(wilds);
	wilds = NULL;
	free(txttotcnt);
	txttotcnt = NULL;
	free(txtcelcnt);
	txtcelcnt = NULL;
	free(txtflrcnt);
	txtflrcnt = NULL;
	free(alltotcnt);
	alltotcnt = NULL;
	free(allcelcnt);
	allcelcnt = NULL;
	free(allflrcnt);
	allflrcnt = NULL;
	detailhdrdone=0;
	ntxtures=0;
	nwilds=0;
}

static char *GetTxture(int n)
{
	static char theTexture[9];

	if (n<0 || n>=ntxtures) return "";
	strncpy(theTexture,txtures+8*n,8);
	theTexture[8]='\0';
	return theTexture;
}

static char *TxtureN(int n)
{
	static char theTexture[9];

	strncpy(theTexture,txtures+8*n,8);
	theTexture[8]='\0';
	return theTexture;
}

static char *GetWild(int n)
{
	static char theTexture[9];

	if (n<0 || n>=nwilds) return "";
	strncpy(theTexture,wilds+8*n,8);
	theTexture[8]='\0';
	return theTexture;
}

static int FindWild(char *theTexture)
{
	int i;

	for (i=0;i<nwilds;i++)
		if (strnicmp(theTexture,wilds+8*i,8)==0)
			return i;
	return -1;
}

static int BTFind(int strt,int end,char *theTexture)
{
	int mid;

	if (end-strt<2)
	{
		if (strnicmp(theTexture,txtures+8*strt,8)<=0)
			return strt;
		if (strnicmp(theTexture,txtures+8*end,8)<=0)
			return end;
		return end+1;
	}
	mid = (strt + end)/2;
	if (strnicmp(theTexture,txtures+8*mid,8)==0)
		return mid;
	if (strnicmp(theTexture,txtures+8*mid,8)<0)
		return BTFind(strt,mid,theTexture);
	else
		return BTFind(mid,end,theTexture);
	return 0;
}

static int BFindTxture(char *theTexture)
{
	if (ntxtures<=0) return 0;
	return BTFind(0,ntxtures-1,theTexture);
}

static int ExistTxture(char *theTexture,int *n)
{
	static char tbuff[9];

	strncpy(tbuff,theTexture,8);
	tbuff[8]='\0';
	if (ntxtures<=0)
	{
		*n = -1;
		return 0;
	}
	*n = BTFind(0,ntxtures-1,tbuff);
	if (*n<0 || *n>ntxtures-1) return 0;
	return (stricmp(GetTxture(*n),tbuff)==0)? 1 : 0;
}

static void PutWild(int n,char *aTexture)
{
	strncpy(wilds+8*n,aTexture,8);
}

static void AddTxture(char *aTexture)
{
	int i;

	if (*aTexture=='-') return;
	for (i=0;i<8 && aTexture[i];i++)
		aTexture[i]=toupper(aTexture[i]);

	if (ntxtures==0)
	{
		strncpy(txtures,aTexture,8);
		ntxtures++;
	}
	else
	{
		i = BFindTxture(aTexture);
		if (ntxtures>i && stricmp(aTexture,GetTxture(i))!=0)
		{
			memmove(txtures+8*i+8,txtures+8*i,(ntxtures-i)*8);
		 	strncpy(txtures+8*i,aTexture,8);
		 	ntxtures++;
		}
		else if (ntxtures==i)
		{
		 	strncpy(txtures+8*i,aTexture,8);
		 	ntxtures++;
		}
	}
}

static void AddWild(char *aTexture)
{
	int i;

	if (*aTexture=='-') return;
	for (i=0;i<8 && aTexture[i];i++)
		aTexture[i]=toupper(aTexture[i]);

	i = FindWild(aTexture);
	if (i<0)
	{
		PutWild(nwilds,aTexture);
		nwilds++;
	}
}

static int WildMatch(char *candidate)
{
	int i;

	if (!nwilds) return 1;
	for (i=0;i<nwilds;i++)
		if (match(GetWild(i),candidate))
			return 1;
	return 0;
}

static void PrintDetailHeader(char *levname)
{
	printf("\nFlat Details for %s\n",levname);
	printf("FLAT     Sect#   CF\n");
	printf("-------------------\n");
}

static void PrintSectorDetail(int secno,char *levname)
{
	int idx;

	if (ExistTxture(Sectors[secno].ctxt,&idx))
	{
		if (!detailhdrdone)
		{
			PrintDetailHeader(levname);
			detailhdrdone=1;
		}
		printf
		(
			"%-8s %5d   C\n",
	    Str8(Sectors[secno].ctxt),
			secno
		);
	}

	if (ExistTxture(Sectors[secno].ftxt,&idx))
	{
		if (!detailhdrdone)
		{
			PrintDetailHeader(levname);
			detailhdrdone=1;
		}
		printf
		(
			"%-8s %5d   F\n",
			Str8(Sectors[secno].ftxt),
			secno
		);
	}
}

//TEXTURE  Uc 1c 2c Lc MinW MaxW MinX MaxX MinY MaxY

static void PrintStatsHeader(char *levname,char *hdrname)
{
	printf("Flat       %s for %s\n",hdrname,levname);
	printf("           Tot   Cel    Flr\n");
	printf("----------------------------\n");
}

static void PrintTextureStats(char *levname)
{
	int i;
	int hdrdone=0;

	if (DoSummary)
	{
		for (i=0;i<ntxtures;i++)
		{
			if ((txtcelcnt[i]+txtflrcnt[i]) || DoBlanks)
			{
				if (!hdrdone)
				{
					printf("\n");
					PrintStatsHeader(levname,"Summary");
					hdrdone=1;
				}
				printf
				(
					"%-8s %5d %5d %5d\n",
		   		GetTxture(i),
					txttotcnt[i],
					txtcelcnt[i],
					txtflrcnt[i]
				);
			}
		}
		if (DoBlanks && !hdrdone)
		{
			printf("\n");
			PrintStatsHeader(levname,"Summary");
			printf("No occurrences of selected flats in this level\n");
		}
		if (hdrdone)
			printf("\n");
	}
}

static void PrintAllStats()
{
	int i;
	int hdrdone=0;

	if (DoTotals)
	{
		for (i=0;i<ntxtures;i++)
		{
			if (allcelcnt[i]+allflrcnt[i])
			{
				if (!hdrdone)
				{
					printf("\n------------------------------------------------------------------------------\n");
					PrintStatsHeader("all levels","TOTALS");
					hdrdone=1;
				}
				printf("%-8s %5d %5d %5d\n",
			   		GetTxture(i),alltotcnt[i],allcelcnt[i],allflrcnt[i]);
			}
			else if (DoBlanks)
			{
				if (!hdrdone)
				{
					printf("\n------------------------------------------------------------------------------\n");
					PrintStatsHeader("all levels","TOTALS");
					hdrdone=1;
				}
				printf("%-8s %5d %5d %5d\n",
			   		GetTxture(i),alltotcnt[i],allcelcnt[i],allflrcnt[i]);
			}
		}
		if (DoBlanks && !hdrdone)
		{
			printf("\n------------------------------------------------------------------------------\n");
			PrintStatsHeader("all levels","TOTALS");
			printf("No occurrences of flats in any level\n");
		}

	}
}

static void AccumulateTextureStats(int secno)
{
	int n;

	if (strncmp("-",Sectors[secno].ctxt,1) &&
					ExistTxture(Sectors[secno].ctxt,&n))
	{
		txtcelcnt[n]++;
		txttotcnt[n]++;
	}

	if (strncmp("-",Sectors[secno].ftxt,1) &&
		            ExistTxture(Sectors[secno].ftxt,&n))
	{
		txttotcnt[n]++;
		txtflrcnt[n]++;
	}
}


static void ScanResourceWads(char **rwads,int nrwads,VTex **flatlist,int *nflats)
{
	int k,c,j;
	WadDir *pdir=NULL;
	AnimData *animbuffer=NULL;

	pdir = malloc (nrwads*sizeof(WadDir));

	for (k=0;k<nrwads;k++)
	{
		if (stricmp(rwads[k],bwadname)==0)
			pst = bst;
		else
			pst = fopen(rwads[k],"rb");

		if (pst)
		{
			dprintf(logfile,"Scanning resource wad %s\n",rwads[k]);

			InitDir(pdir+k);
			fseek(pst,0,SEEK_SET);
			fread(&phdr,sizeof(WadHeader),1,pst);
			ReadDir(&phdr,pdir+k,pst);

			FreeResourceDefinition(&pResDef);
			LocateCategories(pdir+k,&ResDef,&pResDef);

			// list the patches in the resource wad
			c = CategoryOf("FLATS",&pResDef);
			if (c>=0)
				for (j=0;j<pResDef.cat[c].nnames;j++)
					AddNewVTex(flatlist,nflats,1,pResDef.cat[c].Names[j].str,NULL,NULL,0,NULL);

			if (DoAnimated)
			{
				int b=IsIn("ANIMATED",pdir+k);
				if (b>=0)
				{
					int n=pdir[k].dirp[b].reslen;
					int o=pdir[k].dirp[b].resptr;

					animbuffer = realloc(animbuffer,n);

					fseek(pst,o,SEEK_SET);
					fread(animbuffer,n,1,pst);
				}
			}

			if (pst!=bst)
			{
				fclose(pst);
				pst=NULL;
			}
		}
		else dprintf(logfile,"Can't open %s for flat resolution\n",rwads[k]);
	}

	// add the starting and ending name of each animation in the last ANIMATED
	// if they can be found, also add the intermediate names
	if (DoAnimated)
	{
		int i;

		if (animbuffer)
			for (i=0;animbuffer[i].istexture!=-1;i++)
			{
				if (animbuffer[i].istexture==0)
				{
					int s=-1,e=-1,j,k;

					for (k=nrwads-1;k>=0;k--)
					{
						s = IsIn(animbuffer[i].startname,pdir+k);
						e = IsAfter(s,animbuffer[i].endname,pdir+k);

						if (s>=0 && e>=0 && e>=s)
							break;
					}

					if (s>=0 && e>=0 && e>=s)
					{
						for (j=s;j<=e;j++)
							AddTxture(Str8(pdir[k].dirp[j].resname));
					}
					else
					{
						dprintf(logfile,"Warning: Intermediate frames for %s-%s not known\n",animbuffer[i].startname,animbuffer[i].endname);
						AddTxture(animbuffer[i].startname);
						AddTxture(animbuffer[i].endname);
					}
				}
			}
		else // no ANIMATED lump, add all DOOM/DOOM II floor animations
			for (i=0;i<nfanimnames;i++)
				AddTxture(fanimnames[i]);
	}
	for (k=0;k<nrwads;k++)
		FreeDir(pdir+k);
}


int fltumain(int argc,char **argv)
{
	int m,n,i,j,k;
	int cleared=0,nlevs=0;
	int *tmiss=NULL;
	char levname[16],*q;
	char **rwads=NULL;
	int nrwads=0;
	int missing=0;
	char subsname[16]="";

	dprintf(logfile,"\n");

	CopyEnvironmentCLArgs("FLTUSE",argc,argv);
	if (ParseCommandLine(-1,-1))
	{
		FreeCLStrs();
		return 3;
	}

	if (nclfiles<1)
	{
		dprintf(logfile,"\nFLTUSE.EXE by Jim Flynn, Copyright 1997-8 %s -- Freeware --\n\n",PATCHER_VERSION);
		dprintf(logfile,"Analyze the levels in a wad for flat usage. Can work on all\n");
		dprintf(logfile,"flatss in all levels, or on specified flats in specified levels\n");
		dprintf(logfile,"\nUsage: FLTUSE [options] levels[.wad] [MAPnn[-mm]]... [FLAT]...\n");
		dprintf(logfile,"FLAT may contain wildcards *, ?, #, or be ANIMATIONS\n");
		dprintf(logfile,"\nOutput selection option (default is to do all):\n");
		dprintf(logfile," +XY does only X, Y outputs, -XY does all BUT X, Y outputs.\n");
		dprintf(logfile,"  D DETAILS    S SUMMARY    T TOTALS\n");
		dprintf(logfile,"\nUse /R[:resource[.wad]]... to report missing flats\n");
		dprintf(logfile,"Use /W[:resource[.wad]]... to load needed resources and analyze flats\n");
		dprintf(logfile,"Use /U to show unused flats in summary or totals\n");
		dprintf(logfile,"Use /M:flatname to substitute all missing flats with flatname\n");
    dprintf(logfile,"See FLTUSE.TXT for details\n");
		FreeCLStrs();
		return 1;
	}

	DoBlanks=0;
	cleared = 0;
	for (i=0;i<nclopts;i++)
	{
		n = strspn(cloptions[i],"dstDST");
		if (n==strlen(cloptions[i]))
		{
			if (!cleared)	// if first selection option
			{
				if (cloptsense[i])	// clear all if it adds types
					DoDetails=DoSummary=DoTotals=0;
				else if (!cloptsense[i]) // set all if it subtracts types
					DoDetails=DoSummary=DoTotals=1;
				cleared=1;	// but don't do it for following selection opts
			}
			for (j=0;j<strlen(cloptions[i]);j++)
			{
				switch(tolower(cloptions[i][j]))
				{
					case 'd':
						DoDetails = cloptsense[i];
						break;
					case 's':
						DoSummary = cloptsense[i];
						break;
					case 't':
						DoTotals = cloptsense[i];
						break;
				}
			}
		}
		else if (tolower(cloptions[i][0])=='m' && cloptions[i][1]==':')
		{
			if (cloptions[i][2])
				strcpy(subsname,cloptions[i]+2);
		}
		else if (tolower(cloptions[i][0])=='r')
		{
			strcpy(pwadname,"");
			if (cloptions[i][1]==':')
				strcpy(pwadname,cloptions[i]+2);
			AddExt(pwadname,".WAD");
			if (*pwadname)
				AddDynStr(&rwads,&nrwads,pwadname);
			else if (nclfiles>0)
			{
				strcpy(pwadname,clfiles[0]);
				AddExt(pwadname,".WAD");
				AddDynStr(&rwads,&nrwads,pwadname);
			}
			ResolveTextures=1;
		}
		else if (tolower(cloptions[i][0])=='w')
		{
			strcpy(pwadname,"");
			if (cloptions[i][1]==':')
				strcpy(pwadname,cloptions[i]+2);
			AddExt(pwadname,".WAD");
			if (*pwadname)
				AddDynStr(&rwads,&nrwads,pwadname);
			else if (nclfiles>0)
			{
				strcpy(pwadname,clfiles[0]);
				AddExt(pwadname,".WAD");
				AddDynStr(&rwads,&nrwads,pwadname);
			}
		}
		else if (tolower(cloptions[i][0])=='i')
			UseInternalTextures=cloptsense[i];
		else if (tolower(cloptions[i][0])=='u')
			DoBlanks=cloptsense[i];
		else dprintf(logfile,"Warn: command line option: %s not understood\n",cloptions[i]);
	}

	InitVTex();
	AllocHist();

	AddExt(defname,".DEF");
	InitCategories(defname,&ResDef);

	strcpy(bwadname,clfiles[0]);

	for (i=1;i<=32;i++)
		DoMap[i] = 1;
	for (i=1;i<nclfiles;i++)
		if (strnicmp("MAP",clfiles[i],3)==0)
		{
			q = strchr(clfiles[i],'-');			// check for range: Map1-13
			if (q) *q='\0';
			if (NumsOnly(clfiles[i]+3))			// insure range is numeric
				if (!q || NumsOnly(q+1))
				{
					if (!cleared)
						for (j=1;j<=32;j++)				// if maps specified do those given
							DoMap[j] = 0;						// otherwise default to do all
					cleared=1;

					n = atoi(clfiles[i]+3);			// get map number
					m = q? atoi(q+1) : n;

					for	(j=n;j<=m;j++)
						if (1<=j && j<=32)
							DoMap[j]=1;							// if in range, add it to list
						else
							dprintf(logfile,"WARNING: %s not a valid Map for DOOM II\n",clfiles[i]);
				}
		}
		else if (stricmp(clfiles[i],"ANIMATIONS")==0)
			DoAnimated=1;
		else
		{
			if (strcspn(clfiles[i],"*#?")!=strlen(clfiles[i]))
				AddWild(clfiles[i]);	// texture name with wild char
			else
			{
				AddTxture(clfiles[i]);	// pure texture name
				DoSingles++;
			}
		}

	FreeCLStrs();

	AddExt(bwadname,".WAD");
	if (*subsname)
		bst = fopen(bwadname,"r+b");
	else
		bst = fopen(bwadname,"rb");
	if (bst!=NULL)
	{
		int b;

		fread(&bhdr,sizeof(WadHeader),1,bst);
		ReadDir(&bhdr,&bdir,bst);

		ScanResourceWads(rwads,nrwads,&mtxres[0],&mtxcnt[0]);

		if (DoAnimated && (DoSingles==ntxtures))
			for (i=0;i<nfanimnames;i++)
				AddTxture(fanimnames[i]);

		if (UseInternalTextures)
		{
			ntxtures=0;
			for (i=0;i<mtxcnt[0];i++)
				AddTxture(mtxres[0][i].name);
		}

		if (ntxtures==0 || nwilds)	// if no textures specified or added
		{							 							// add all textures occurring in all levels
			nlevs=0;									// also match if wild textures specified
			for (i=1;i<=32;i++)
				if (DoMap[i])
				{
					sprintf(levname,"MAP%02d",i);
					b = IsIn(levname,&bdir);
					if (b>=0)
					{
						ReadLevelData(levname,&bdir,bst,NLevObj());
						dprintf(logfile,"Adding flats in %s\n",levname);
						for (j=0;j<NSectors;j++)
						{
							if (WildMatch(Str8(Sectors[j].ctxt)))
								AddTxture(Str8(Sectors[j].ctxt));
							if (WildMatch(Str8(Sectors[j].ftxt)))
								AddTxture(Str8(Sectors[j].ftxt));
						}
						FreeLevelData();
						nlevs++;
					}
				}
			if (nlevs) dprintf(logfile,"\n");
		}

		if (ResolveTextures)
		{
			tmiss = malloc(ntxtures*sizeof(int));
			memset(tmiss,0,ntxtures*sizeof(int));

			for (k=0;k<ntxtures;k++)
			{
				tmiss[k] = IsInVTex(GetTxture(k),mtxres[0],mtxcnt[0])>=0;
				if (!tmiss[k])
				{
					dprintf(logfile,"ERROR: Missing flat %s in resource wads\n",GetTxture(k));
					missing=1;
				}
			}
			if (missing)
			{
				if (*subsname)
				{
					dprintf(logfile,"Info: Replacing missing flats with %s\n",subsname);
					for (k=1;k<32;k++)
					{
						if (DoMap[k])
						{
							int b = IsIn(stringf("MAP%02d",k),&bdir);
							int c = IsAfter(b,"SECTORS",&bdir);
							if (c<b+11)
							{
								fseek(bst,bdir.dirp[c].resptr,SEEK_SET);
								Sectors = realloc(Sectors,bdir.dirp[c].reslen);
								fread(Sectors,bdir.dirp[c].reslen,1,bst);
								NSectors = bdir.dirp[c].reslen/sizeof(Sector);

								for (i=0;i<NSectors;i++)
								{
									for (j=0;j<ntxtures;j++)
										if (!tmiss[j])
										{
											if (stricmp(Str8(Sectors[i].ctxt),GetTxture(j))==0)
												strncpy(Sectors[i].ctxt,subsname,8);
											if (stricmp(Str8(Sectors[i].ftxt),GetTxture(j))==0)
												strncpy(Sectors[i].ftxt,subsname,8);
										}

								}
								fseek(bst,bdir.dirp[c].resptr,SEEK_SET);
								fwrite(Sectors,bdir.dirp[c].reslen,1,bst);
							}
						}
					}
					ntxtures=0;
					AddTxture(subsname);
					dprintf(logfile,"Info: Analyzing substituted flat: %s only\n",subsname);
				}
				else
				{
					int n=ntxtures;
					dprintf(logfile,"Info: Analyzing missing flats only\n");
					ntxtures=0;
					for (k=0;k<n;k++)
						if (!tmiss[k])
							AddTxture(TxtureN(k));
				}
			}
			else
			{
				ntxtures=0;
				dprintf(logfile,"\nInfo: No flats in levels missing in resource wads\n");
				dprintf(logfile,"\n");
			}
			free(tmiss);
			FreeVTex();
		}

		nlevs=0;
		dprintf(logfile,"\n");
		for (i=1;i<=32;i++)
		{
			if (DoMap[i])
			{
				detailhdrdone=0;
				sprintf(levname,"MAP%02d",i);
				b = IsIn(levname,&bdir);
				if (b>=0)
				{
					if (ntxtures)
					{
						dprintf(logfile,"Analyzing flats in %s\n",levname);

						InitMapHist();
						ReadLevelData(levname,&bdir,bst,NLevObj());

						for (j=0;j<NSectors;j++)
						{
							if (DoDetails)
								PrintSectorDetail(j,levname);
							AccumulateTextureStats(j);
						}

						PrintTextureStats(levname);
						for (j=0;j<ntxtures;j++)
						{
							allcelcnt[j] += txtcelcnt[j];
							allflrcnt[j] += txtflrcnt[j];
							alltotcnt[j] += txttotcnt[j];
						}
						nlevs++;
						FreeLevelData();
					}
				}
			}
		}

		if (ntxtures && !nlevs)
			dprintf(logfile,"No maps found to analyze usage in\n");
		if (nlevs) fprintf(stderr,"\n");
		if (nlevs>1) PrintAllStats();

	}
	else dprintf(logfile,"Cant open %s for read\n",bwadname);

	return 0;
}


