#include "patch.h"

int ByPercent=0;
int Upper=255,Lower=0;
Sector *sectors=NULL;

void FreeGamStructures()
{
	free(sectors);
	sectors = NULL;
	FreeDir(&pdir);
	FreeResourceDefinition(&ResDef);
	CloseStreams();
}

int gammain(int argc,char **argv)
{
	int i,j,k,n;
	char *p,mapsel[128];
	int cleared=0;
	double pct=0;
	int inc=0,nsectors=0;

	CopyEnvironmentCLArgs("GAMMA",argc,argv);
	if (ParseCommandLine(-1,2))
	{
		FreeCLStrs();
		return 3;
	}


	if (nclfiles!=1 && nclfiles!=2)
	{
		dprintf(logfile,"\nGAMMA.EXE by Jim Flynn, Copyright 1996 v1.0 -- Freeware --\n\n");
		dprintf(logfile,"Change the light levels in one or all levels of a wad by a\n");
		dprintf(logfile,"percentage or absolute increment. Note information is LOST\n");
		dprintf(logfile,"during conversion - backup BEFORE applying GAMMA\n\n");
		dprintf(logfile,"Usage: GAMMA option wadfile[.wad] [Mapnn]\n");
		dprintf(logfile,"\n Options, use SET GAMMA=options to set defaults:\n");
		dprintf(logfile,"+nnn  add nnn to each sector lighting level in affected levels\n");
		dprintf(logfile,"-nnn  sub nnn from each sector lighting level in affected levels\n");
		dprintf(logfile,"+nn%%  increase each sector lighting level by nn percent\n");
		dprintf(logfile,"-nn%%  decrease each sector lighting level by nn percent\n");
		dprintf(logfile,"\n/U=nnn  do not increase any light level past upper bound of nnn\n");
		dprintf(logfile,"/L=nnn  do not decrease any light level below lower bound of nnn\n");
		dprintf(logfile,"\n See GAMMA.TXT for details.\n");
		FreeCLStrs();
		return(1);
	}

	cleared=0;
	strcpy(outname,"");
	for (i=0;i<nclopts;i++)
	{
		if (tolower(cloptions[i][0])=='u' && cloptions[i][1]=='=')
			Upper = atoi(cloptions[i]+2);
		else if (tolower(cloptions[i][0])=='l' && cloptions[i][1]=='=')
			Lower = atoi(cloptions[i]+2);
		else
		{
			p = strchr(cloptions[i],'%');
			if (p)
			{
				*p='\0';
				n = atoi(cloptions[i]);
				pct = cloptsense[i]? n/100.0 : -n/100.0;
				ByPercent=1;
			}
			else
			{
				n = atoi(cloptions[i]);
				inc = cloptsense[i]? n : -n;
				ByPercent=0;
			}
		}
	}

	AddExt(defname,".DEF");
	InitCategories(defname,&ResDef);

	strcpy(pwadname,clfiles[0]);
	strcpy(mapsel,"");
	if (nclfiles>1 && IsDMap(clfiles[1]))
	{
		strcpy(mapsel,clfiles[1]);
		SingleMap=1;
	}

	FreeCLStrs();
	AddExt(pwadname,".WAD");

	pst = fopen(pwadname,"r+b");
	if (pst!=NULL)
	{
		fread(&phdr,sizeof(WadHeader),1,pst);
		ReadDir(&phdr,&pdir,pst);

		for (i=0;i<pdir.nentries;i++)
		{
			if (IsMapName(pdir.dirp+i) && (!SingleMap || strnicmp(mapsel,pdir.dirp[i].resname,5)==0))
			{
				for (j = i+1,k=-1;j<i+11;j++)
				{
					if (strnicmp(pdir.dirp[j].resname,"SECTORS",7)==0)
					{
						k=j;
						break;
					}
				}
				if (k>=0)
				{
					sectors = (Sector *)realloc(sectors,pdir.dirp[k].reslen);
					fseek(pst,pdir.dirp[k].resptr,SEEK_SET);
					fread((char *)sectors,pdir.dirp[k].reslen,1,pst);
					nsectors = pdir.dirp[k].reslen/sizeof(Sector);

					for (j=0;j<nsectors;j++)
					{
						if (ByPercent)
			 				sectors[j].lite *= 1+pct;
						else
			 				sectors[j].lite += inc;
						if (sectors[j].lite<Lower) sectors[j].lite=Lower;
						if (sectors[j].lite>Upper) sectors[j].lite=Upper;
					}

					fseek(pst,pdir.dirp[k].resptr,SEEK_SET);
					SafeWrite((char *)sectors,pdir.dirp[k].reslen,1,pst);
				}
			}
		}

	}
	else dprintf(logfile,"Can't open %s for modification\n",pwadname);

	
	//FreeGamStructures();

	return 0;
}

