#include "patch.h"

void FreeHistResources()
{
	FreeDir(&pdir);
	CloseStreams();
}

int histmain(int argc,char **argv)
{
	int i,j,k,n,o,o1,n1,omin;
	char *p,*q;
	int cleared=0;
	int curoff;

	dprintf(logfile,"\n");

	CopyEnvironmentCLArgs("HIST",argc,argv);
	if (ParseCommandLine(-1,1))
	{
		FreeCLStrs();
		return 3;
	}

	if (nclfiles!=1)
	{
		dprintf(logfile,"\nHIST.EXE %s by Jim Flynn, Copyright 1996-7 -- Freeware --\n",PATCHER_VERSION);
		dprintf(logfile,"\nView the history in a wad output by Patcher v4.0 or later\n");
		dprintf(logfile,"\nGeneral Options, use SET HIST= to make options default\n");
		dprintf(logfile,"/C Remove the history lump from the wadfile after reporting it\n");
		dprintf(logfile,"\nUsage: HIST wadfile[.wad]\n");
        dprintf(logfile,"\nSee HIST.TXT for details\n");

		FreeCLStrs();
		return(1);
	}

	for (i=0;i<nclopts;i++)
	{
		if (tolower(cloptions[i][0]=='c'))
			ClearHistory=cloptsense[i];
		else dprintf(logfile,"Warn: command line option: %s not understood\n",cloptions[i]);
	}

	cleared=0;
	strcpy(outname,"");

	strcpy(pwadname,clfiles[0]);
	FreeCLStrs();

	AddExt(pwadname,".WAD");

	// open the wad file
	pst = fopen(pwadname,"r+b");
	if (pst!=NULL)
	{
		fread(&phdr,sizeof(WadHeader),1,pst);
		ReadDir(&phdr,&pdir,pst);

		// find the history lump
		i = IsIn("HISTORY",&pdir);
		if (i>=0)
		{
			// report the history contents
			o = pdir.dirp[i].resptr;
			n = pdir.dirp[i].reslen;
			curoff=o+n;
			fseek(pst,o,SEEK_SET);
			p = malloc(n);
			fread(p,n,1,pst);
			for (q=p,k=0;k<n;k++,q++)
				putc(*q,stdout);
			free(p);

			// if history clear option, delete the history lump
			if (ClearHistory)
			{
				omin=0;
				while (omin>=0)
				{
					for (j=0,omin=-1;j<pdir.nentries;j++)
					{
						o1=pdir.dirp[j].resptr;
						n1=pdir.dirp[j].reslen;
						if (o1>curoff && (omin<0 || o1<pdir.dirp[omin].resptr))
							omin = j;
					}
					if (omin<0) break;

					o1 = pdir.dirp[omin].resptr;
					n1 = pdir.dirp[omin].reslen;
					fseek(pst,o1,SEEK_SET);
					p = malloc(n1);
					fread(p,n1,1,pst);
					fseek(pst,curoff,SEEK_SET);
					SafeWrite(p,n1,1,pst);
					pdir.dirp[omin].resptr = curoff;
					curoff += n1;
					free(p);
				}
				if (i<pdir.nentries-1)
					memmove(pdir.dirp+i,pdir.dirp+i+1,sizeof(WadDirEntry)*pdir.nentries-i-1);
				pdir.nentries--;
				phdr.waddirlen--;
				phdr.waddiraddr = curoff;
				fseek(pst,curoff,SEEK_SET);
				SafeWrite(pdir.dirp,sizeof(WadDirEntry),pdir.nentries,pst);
				fseek(pst,0,SEEK_SET);
				SafeWrite(&phdr,sizeof(WadHeader),1,pst);
			}
		}
		else dprintf(logfile,"%s: No History\n",pwadname);
	}
	else dprintf(logfile,"Can't open %s for modification\n",pwadname);

	//FreeHistResources();

	return 0;
}

