#include "patch.h"

int DoMap[100];

void FreeNoSecretStructures()
{
	FreeDir(&pdir);
	FreeResourceDefinition(&ResDef);
	CloseStreams();
}

int nosmain(int argc,char **argv)
{
	int i,j,m,n;
	int cleared=0;
	char mapsel[256],*q;

	dprintf(logfile,"\n");

	CopyEnvironmentCLArgs("NOSECRET",argc,argv);
	if (ParseCommandLine(-1,-1))
	{
		FreeCLStrs();
		return 3;
	}

	if (!nclfiles)
	{
		dprintf(logfile,"\nNOSECRET %s by Jim Flynn, Copyright 1996-7  -- Freeware --\n",PATCHER_VERSION);
		dprintf(logfile,"\nClear all secret sectors in the specified levels\n");
		dprintf(logfile,"\nUsage: NOSECRET [options] wadfile[.wad] [MapNN]... \n");
		dprintf(logfile,"\n General options, use SET NOSECRET=options to set defaults:\n");
		dprintf(logfile,"\n See NOSECRET.TXT for details.\n");
						 
		FreeCLStrs();
		return(1);
	}

	cleared=0;
	strcpy(pwadname,clfiles[0]);

	AddExt(pwadname,".WAD");
	AddExt(defname,".DEF");

	InitCategories(defname,&ResDef);

	for (i=1;i<=32;i++)
		DoMap[i] = 1;
	cleared=0;
	for (i=1;i<nclfiles;i++)
		if (strnicmp("MAP",clfiles[i],3)==0)
		{
			q = strchr(clfiles[i],'-');			// check for range: Map1-13
			if (q) *q='\0';
			if (NumsOnly(clfiles[i]+3))			// insure range is numeric
				if (!q || NumsOnly(q+1))
				{
					if (!cleared)
						for (j=1;j<=32;j++)		// if maps specified do those given
							DoMap[j] = 0;		// otherwise default to do all
					cleared=1;

					n = atoi(clfiles[i]+3);		// get map number
					m = q? atoi(q+1) : n;

					for (j=n;j<=m;j++)
						if (1<=j && j<=32)
							DoMap[j]=1;			// if in range, add it to list
						else
							dprintf(logfile,"WARNING: %s not a valid Map for DOOM II\n",clfiles[i]);
				}
		}

	FreeCLStrs();

	pst = fopen(pwadname,"r+b");
	if (pst!=NULL)
	{
		fread(&phdr,sizeof(WadHeader),1,pst);
		ReadDir(&phdr,&pdir,pst);

		for (i=1;i<32;i++)
		{
			if (DoMap[i])
			{
				sprintf(mapsel,"MAP%02d",i);
				if (!ReadLevelData(mapsel,&pdir,pst,NLevObj()))
				{
	  				ClearSecrets();
					j = IsIn(mapsel,&pdir);
					if (j>=0)
					{
						j = IsAfter(j,"SECTORS",&pdir);
						if (j>=0)
						{
							fseek(pst,pdir.dirp[j].resptr,SEEK_SET);
							SafeWrite(Sectors,sizeof(Sector),NSectors,pst);
		        			dprintf(logfile,"%s has had the secrets in %s cleared\n",pwadname,mapsel);
						}
					}
				}
			}
			FreeLevelData();
		}
	}

	//FreeNoSecretStructures();
	return errorlev;
}

