#include "patch.h"

RGBQUAD *GetPalette(WadDir *dir,FILE *st,int idx)
{
	int p=-1,c,palset=0;
	RGBQUAD *pal;
	UBYTE *rawpal,*q;

	pal = (RGBQUAD *)malloc(256*sizeof(RGBQUAD));

	rawpal = (UBYTE *)malloc(768*sizeof(UBYTE));

	if (dir && st && idx>=0)						// if a wad reference
	{
		fseek(st,dir->dirp[idx].resptr,SEEK_SET);	
		fread(rawpal,768,1,st);
	}
	else if ((c=CategoryOf("PALETTE",&ResDef))>=0)	// else take from ResDef
	{
		dprintf(logfile,"Using palette from resource definition file %s\n",defname);
		for (p=0,q=rawpal;p<768;p++)
			*q++ = atoi(ResDef.cat[c].Names[p].str);
	}
	else
	{
 		dprintf(logfile,"Defaulting to DOOM palette\n");
		memcpy(pal,DoomPalette,256*sizeof(RGBQUAD));
		palset = 1;
	}

	if (!palset)
		for (p=0;p<256;p++)
		{
			pal[p].rgbRed = rawpal[0+3*p];
			pal[p].rgbGreen = rawpal[1+3*p];
			pal[p].rgbBlue = rawpal[2+3*p];
			pal[p].rgbReserved = 0;
		}

	// this allows the wad designer to control which palette slot represents
	// transparencies in .BMPs, and to set its rendered color value on output
	// Thanks to Ty for identifying and helping to solve this glitch

	if (XParencyAdjust)
	{
		int xpar_red = 0;
		int xpar_green = 255;
		int xpar_blue = 255;
		int xpar_slot = -1;
		xparent = 247;

		c = CategoryOf("XPARENT",&ResDef);
		if (c>=0 && ResDef.cat[c].nnames>=3)
		{
			xpar_red = atoi(ResDef.cat[c].Names[0].str);
			xpar_green = atoi(ResDef.cat[c].Names[1].str);
			xpar_blue = atoi(ResDef.cat[c].Names[2].str);
		}
		if (c>=0 && ResDef.cat[c].nnames>=4)
			xpar_slot = atoi(ResDef.cat[c].Names[3].str);

		if (xpar_slot<0 || xpar_slot>255)
		{
			// Ty 07/03/98 - Added logic to dynamically set transparent color to whatever
			// index cyan is.  Probably need to do this as a separate setting in the RES
			// file but this will do for now.

			for (p=0;p<256;p++)
			{
				if (pal[p].rgbRed==xpar_red  &&
					  pal[p].rgbGreen==xpar_green &&
						pal[p].rgbBlue==xpar_blue)
					xparent = p;
			} // takes the last one if more than one, though there shouldn't be
		}
		else
		{
			xparent = xpar_slot;
			pal[xparent].rgbRed = xpar_red;
			pal[xparent].rgbGreen = xpar_green;
			pal[xparent].rgbBlue = xpar_blue;
		}
	}

	c = CategoryOf("SIGNLOOK",&ResDef);
	if (c>=0)
	{
		for (p=0;p<16;p++)
			redidx[p] = atoi(ResDef.cat[c].Names[p].str);
		for (p=0;p<16;p++)
			greenidx[p] = atoi(ResDef.cat[c].Names[p+16].str);
		for (p=0;p<16;p++)
			blueidx[p] = atoi(ResDef.cat[c].Names[p+32].str);
		for (p=0;p<16;p++)
			whiteidx[p] = atoi(ResDef.cat[c].Names[p+48].str);
		for (p=0;p<16;p++)
			grayidx[p] = atoi(ResDef.cat[c].Names[p+64].str);
		for (p=0;p<16;p++)
			yellowidx[p] = atoi(ResDef.cat[c].Names[p+80].str);
	}

	free(rawpal);
	return pal;
}

