#include "patch.h"

TextureLump *GetTextureLump(int c,WadTextures *wt,int *lno)
{
	if (strnicmp(ResDef.cat[c].secname,"TEXTURE",7))
		return NULL;

	switch(ResDef.cat[c].secname[7])
	{
		case 'S': case 's': case '1':
			*lno = 1;
			return	&wt->t1;
		case '2':
			*lno = 2;
			return	&wt->t2;
		case '3':
			*lno = 3;
			return	&wt->t3;
		default:
			break;
	}
	return NULL;
}

char *GetStrIdx(StrIdxAry *sa,int num,int n)
{
	if (0<=n && n<num)
		return sa[n].str;
	else
		return NULL;
}

int BStrIdxAryFind(StrIdxAry *sa,int strt,int end,char *theString)
{
	int mid;

	if (end-strt<2)
	{
		if (stricmp(theString,sa[strt].str)<=0)
			return strt;
		if (stricmp(theString,sa[end].str)<=0)
			return end;
		return end+1;
	}
	mid = (strt + end)/2;
	if (stricmp(theString,sa[mid].str)==0)
		return mid;
	if (stricmp(theString,sa[mid].str)<0)
		return BStrIdxAryFind(sa,strt,mid,theString);
	else
		return BStrIdxAryFind(sa,mid,end,theString);
	return 0;
}

int BStrIdxFind(StrIdxAry *sa,int num,char *theString)
{
	return BStrIdxAryFind(sa,0,num-1,theString);
}

int StrIdxFind(StrIdxAry *sa,int num,char *theString)
{
	int i;

	for (i=0;i<num;i++)
		if (stricmp(GetStrIdx(sa,num,i),theString)==0)
			return i;
	return -1;
}

int ExistStrIdx(StrIdxAry *sa,int num,char *theString,int *n)
{
	*n = BStrIdxFind(sa,num,theString);
	if (*n<0 || *n>num-1) return 0;
	return (stricmp(GetStrIdx(sa,num,*n),theString)==0)? 1 : 0;
}

int IsStrIdxEqual(StrIdxAry *sa,int num,int n,char *theString)
{
	if (n<0 || n>=num)
		return 0;
	return stricmp(sa[n].str,theString)==0? 1 : 0;
}

void PutStrIdx(StrIdxAry *sa,int num,int n,char *theString)
{
	if (n<0 || n>=num)
		return;
	sa[n].str = (char *)realloc(sa[n].str,strlen(theString)+1);
	strcpy(sa[n].str,theString);
}

void AddStrIdxSorted(StrIdxAry **sa,int *num,char *theString)
{
	int i,j;

	i = BStrIdxFind(*sa,*num,theString);
	if (stricmp(theString,GetStrIdx(*sa,*num,i))!=0)
	{
		for (j=0;theString[j];j++)
			theString[j]=toupper(theString[j]);

		*sa = (StrIdxAry *)realloc(*sa,((*num)+1)*sizeof(StrIdxAry));
		memmove((*sa)+i+1,(*sa)+i,((*num)-i)*sizeof(StrIdxAry));

		(*sa)[i].str = (char *)malloc(strlen(theString)+1);
		strcpy((*sa)[i].str,theString);
		(*sa)[i].lidx = i;
		(*sa)[i].didx = -1;
		(*num)++;

		for (j=i+1;j<*num;j++)
			(*sa)[j].lidx++;
	}
}

void AppendStrIdx(StrIdxAry **sa,int *num,char *theString)
{
	int j;

	if (StrIdxFind(*sa,*num,theString)<0)
	{
		for (j=0;theString[j];j++)
			theString[j]=toupper(theString[j]);

		*sa = (StrIdxAry *)realloc(*sa,((*num)+1)*sizeof(StrIdxAry));

		(*sa)[*num].str = (char *)malloc(strlen(theString)+1);
		strcpy((*sa)[*num].str,theString);
		(*sa)[*num].lidx = *num;
		(*sa)[*num].didx = -1;
		(*num)++;
	}
}

void ListStrIdx(StrIdxAry **sa,int *num,char *theString)
{
	*sa = (StrIdxAry *)realloc(*sa,((*num)+1)*sizeof(StrIdxAry));

	(*sa)[*num].str = (char *)malloc(strlen(theString)+1);
	strcpy((*sa)[*num].str,theString);
	(*sa)[*num].lidx = *num;
	(*sa)[*num].didx = -1;
	(*num)++;
}


void FreeStrIdxAry(StrIdxAry **sa,int *num)
{
	int i;

	for (i=0;i<(*num);i++)
		free((*sa)[i].str);
	free(*sa);
	*sa = NULL;
	*num = 0;
}

void InitStrIdxAry(StrIdxAry **sa,int *num)
{
	*sa = NULL;
	*num = 0;
}

void AddExtn(Category *rt,char *extn)
{

	AppendStrIdx(&rt->Extns,&rt->nextns,extn);
}

void SortExtn(Category *rt,char *extn)
{
	AddStrIdxSorted(&rt->Extns,&rt->nextns,extn);
}

char *GetExtn(Category *rt,int idx)
{
	return GetStrIdx(rt->Extns,rt->nextns,idx);
}

void AddName(Category *rt,char *name)
{
	AppendStrIdx(&rt->Names,&rt->nnames,name);
}

void ListName(Category *rt,char *name)
{
	ListStrIdx(&rt->Names,&rt->nnames,name);
}


void SortName(Category *rt,char *name)
{
	AddStrIdxSorted(&rt->Names,&rt->nnames,name);
}

char *GetName(Category *rt,int idx)
{
	return GetStrIdx(rt->Names,rt->nnames,idx);
}

int CategoryOf(char *catname,ResourceDefinition *rd)
{
	int i;

	for (i=0;i<rd->ncats;i++)
		if (stricmp(catname,rd->cat[i].secname)==0)
			return i;
	return -1;
}

int ResourceExists(char *catname,char *resname,ResourceDefinition *rd)
{
	int i,c;

	c = CategoryOf(catname,rd);
	if (c<0) return 0;

	for (i=0;i<rd->cat[c].nnames;i++)
		if (stricmp(resname,rd->cat[c].Names[i].str)==0)
			return 1;

	return 0;
}

int IsSectionEnabled(char *sec)
{
	if (stricmp(sec,"LUMPS")==0) return DoLumps;
	if (strnicmp(sec,"TEXTURE",7)==0) return DoTextures;
	if (stricmp(sec,"LEVELS")==0) return DoWads;
	if (stricmp(sec,"SOUNDS")==0) return DoEffects;
	if (stricmp(sec,"MUSICS")==0) return DoMusics;
	if (stricmp(sec,"GRAPHICS")==0) return DoGraphics;
	if (stricmp(sec,"SPRITES")==0) return DoSprites;
	if (stricmp(sec,"PATCHES")==0) return DoPatches;
	if (stricmp(sec,"FLATS")==0) return DoFlats;
	if (stricmp(sec,"HISTORY")==0) return CategoryOf("HISTORY",&ResDef)>=0;
	return DoNonStandard;
}

void InitCategory(ResourceDefinition *rd,int i)
{
	strcpy(rd->cat[i].secname,"");
	strcpy(rd->cat[i].defaultdir,"");
	rd->cat[i].idm = ID_NONE;
	rd->cat[i].mark = 0;
	InitStrIdxAry(&rd->cat[i].Extns,&rd->cat[i].nextns);
	InitStrIdxAry(&rd->cat[i].Names,&rd->cat[i].nnames);
}

void FreeCategory(ResourceDefinition *rd,int i)
{
	FreeStrIdxAry(&rd->cat[i].Extns,&rd->cat[i].nextns);
	FreeStrIdxAry(&rd->cat[i].Names,&rd->cat[i].nnames);
}

void InitResourceDefinition(ResourceDefinition *rd)
{
	rd->cat = NULL;
	rd->ncats = 0;
}

void FreeResourceDefinition(ResourceDefinition *rd)
{
	int i;

	for (i=0;i<rd->ncats;i++)
		FreeCategory(rd,i);
	free(rd->cat);

	rd->cat = NULL;
	rd->ncats = 0;
}

int ReadResourceDefinition(char *filepath,ResourceDefinition *rd)
{
	int i,j;
	FILE *st=NULL;
	char buffer[256];
	char *p;
	char *tok;
	int lineno=0;

	strcpy(resdefpath,"");
	if ((p=searchpath(filepath)))
		st = fopen(p,"r");

	if (st)
	{
		strcpy(resdefpath,p);
		rd->ncats=-1;
		while (fgets(buffer,256,st))
		{
			p = strchr(buffer,'\n');
			if (p) *p='\0';

			lineno++;

 			StripComment(buffer);
			Trim(buffer);

			if (*buffer=='[')
			{
				p = strchr(buffer,']');
				if (p)
				{
					rd->ncats++;
					rd->cat = (Category *)realloc(rd->cat,(rd->ncats+1)*sizeof(Category));

					InitCategory(rd,rd->ncats);

					*p='\0';
					Trim(buffer+1);
					strupr(buffer+1);
					strcpy(rd->cat[rd->ncats].secname,buffer+1);

					tok = strtok(p+1," \t");
					if (strcmp(tok,"!InFo!"))
					{
						strcpy(rd->cat[rd->ncats].defaultdir,tok);
						tok = strtok(NULL," \t");

						while (tok && *tok=='.')
						{
							AddExtn(rd->cat+rd->ncats,tok);
							tok = strtok(NULL," \t");
						}

						rd->cat[rd->ncats].idm = ID_NONE;
						rd->cat[rd->ncats].mark = 0;
						if (tok)
						{
							if (stricmp(tok,"listed")==0)
								rd->cat[rd->ncats].idm = ID_LISTED;
							else if (stricmp(tok,"marked")==0)
							{
								rd->cat[rd->ncats].idm = ID_MARKED;
								rd->cat[rd->ncats].mark = toupper(rd->cat[rd->ncats].secname[0]);
							}
							else
								rd->cat[rd->ncats].idm = ID_NONE;
						}
						else
						{
							dprintf(logfile,"Missing section %s type in game definition\n",rd->cat[rd->ncats].secname);
							rd->ncats++;
							FreeResourceDefinition(rd);
							fclose(st);
							return 1;
						}
					}
					else
					{
						strcpy(rd->cat[rd->ncats].defaultdir,"");
						rd->cat[rd->ncats].idm = ID_INFO;
						rd->cat[rd->ncats].mark = 0;
					}
				}
				else
				{
					dprintf(logfile,"Unclosed section brace: %s at line #%d\n",buffer,lineno);
					rd->ncats++;
					FreeResourceDefinition(rd);
					fclose(st);
					return 1;
				}
			}
			else if (*buffer)
			{
				tok = strtok(buffer," \t");
				while (tok)
				{
					if (rd->cat[rd->ncats].idm==ID_LISTED)
						AddName(rd->cat+rd->ncats,tok);
					else if (rd->cat[rd->ncats].idm==ID_INFO)
						ListName(rd->cat+rd->ncats,tok);
					tok = strtok(NULL," \t");
				}
			}
		}
		rd->ncats++;
		fclose(st);

		// processing extensions
		
		for (i=0;i<rd->ncats;i++)
		{
			for (j=0;j<rd->cat[i].nextns;j++)
			{
				p = strchr(rd->cat[i].Extns[j].str,':');
				if (p)
					*p++ = '\0';

				// if no data type, asssume generic
				if (!p || !*p || stricmp(p,"GENERIC")==0) 
					rd->cat[i].Extns[j].didx = DT_GENERIC;
				else if (stricmp(p,"LEVELS")==0)
					rd->cat[i].Extns[j].didx = DT_LEVELS;
				else if (strnicmp(p,"TEXTURE",7)==0)
					rd->cat[i].Extns[j].didx = DT_TEXTURES;
				else if (stricmp(p,"SOUNDS")==0)
					rd->cat[i].Extns[j].didx = DT_SOUNDS;
				else if (stricmp(p,"PICS")==0)
					rd->cat[i].Extns[j].didx = DT_PICS;
				else if (stricmp(p,"FLATS")==0)
					rd->cat[i].Extns[j].didx = DT_FLATS;
			}
		}
	}

	return (rd->ncats>0)? 0 : 1;
}


void InitCategories(char *defname,ResourceDefinition *rd)
{
	int i;
	Category *r;

	InitResourceDefinition(rd);

	rd->ncats=-1;	// start in position to increment to zeroth category
	if (defname && *defname)
		if (!ReadResourceDefinition(defname,rd))
		{
			dprintf(logfile,"Initializing resource definitions from %s\n",defname);
			return;
		}

	// If can't find or read the resource definition, default to standard one

	if (rd->ncats<=0)
	{
		rd->cat = (Category *)malloc(sizeof(Category)*10);
		for (i=0;i<10;i++)
			InitCategory(rd,i);
		r = rd->cat+0;
		dprintf(logfile,"Defaulting to standard DOOM II resource definitions\n");
		strcpy(r->secname,"LUMPS");
		strcpy(r->defaultdir,"LUMPS");
		r->idm = ID_LISTED;
		r->mark = 0;
		for (i=I_PLAYPAL;i<=I_DMXGUSC;i++)
			AddName(r,resstr[i]);
		AddExtn(r,".LMP");
		r->Extns[0].didx = DT_GENERIC;
		
		r = rd->cat+1;
		strcpy(r->secname,"LEVELS");
		strcpy(r->defaultdir,"LEVELS");
		r->idm = ID_LISTED;
		r->mark = 0;
		for (i=1;i<=32;i++)
			AddName(r,stringf("MAP%02d",i));
		AddExtn(r,".WAD");
		r->Extns[0].didx = DT_LEVELS;

		r = rd->cat+2;
		strcpy(r->secname,"LEVOBJ");
		strcpy(r->defaultdir,"");
		r->idm = ID_INFO;
		r->mark = 0;
		AddName(r,"THINGS");
		AddName(r,"LINEDEFS");
		AddName(r,"SIDEDEFS");
		AddName(r,"VERTEXES");
		AddName(r,"SEGS");
		AddName(r,"SSECTORS");
		AddName(r,"NODES");
		AddName(r,"SECTORS");
		AddName(r,"REJECT");
		AddName(r,"BLOCKMAP");
				
		r = rd->cat+3;
		strcpy(r->secname,"TEXTURES");
		strcpy(r->defaultdir,"TEXTURES");
		r->idm = ID_LISTED;
		r->mark = 0;
		AddName(r,"TEXTURE1");
		AddName(r,"PNAMES");
		AddExtn(r,".RES");
		AddExtn(r,".SGN");
		r->Extns[0].didx = DT_TEXTURES;
		r->Extns[1].didx = DT_TEXTURES;
		
		r = rd->cat+4;
		strcpy(r->secname,"SOUNDS");
		strcpy(r->defaultdir,"SOUNDS");
		r->idm = ID_LISTED;
		r->mark = 0;
		for (i=I_DPPISTOL;i<=I_DSRADIO;i++)
			AddName(r,resstr[i]);
		AddExtn(r,".WAV");
		AddExtn(r,".TXT");
		r->Extns[0].didx = DT_SOUNDS;
		r->Extns[1].didx = DT_GENERIC;
		
		r = rd->cat+5;
		strcpy(r->secname,"MUSICS");
		strcpy(r->defaultdir,"MUSICS");
		r->idm = ID_LISTED;
		r->mark = 0;
		for (i=I_D_RUNNIN;i<=I_D_DM2INT;i++)
			AddName(r,resstr[i]);
		AddExtn(r,".MUS");
		AddExtn(r,".MID");
		r->Extns[0].didx = DT_GENERIC;
		r->Extns[1].didx = DT_GENERIC;
		
		r = rd->cat+6;
		strcpy(r->secname,"GRAPHICS");
		strcpy(r->defaultdir,"GRAPHICS");
		r->idm = ID_LISTED;
		r->mark = 0;
		for (i=I_HELP;i<=I_INTERPIC;i++)
			AddName(r,resstr[i]);
		AddExtn(r,".BMP");
		r->Extns[0].didx = DT_PICS;

		r = rd->cat+7;
		strcpy(r->secname,"SPRITES");
		strcpy(r->defaultdir,"SPRITES");
		r->idm = ID_MARKED;
		r->mark = 'S';
		AddExtn(r,".BMP");
		r->Extns[0].didx = DT_PICS;

		r = rd->cat+8;
		strcpy(r->secname,"PATCHES");
		strcpy(r->defaultdir,"PATCHES");
		r->idm = ID_MARKED;
		r->mark = 'P';
		AddExtn(r,".BMP");
		r->Extns[0].didx = DT_PICS;

		r = rd->cat+9;
		strcpy(r->secname,"FLATS");
		strcpy(r->defaultdir,"FLATS");
		r->idm = ID_MARKED;
		r->mark = 'F';
		AddExtn(r,".BMP");
		r->Extns[0].didx = DT_FLATS;

		rd->ncats = 10;
	}
}

int IsCategoryMarker(int c,char *str,ResourceDefinition *rd)
{
	int mch;

	if (c<0) return 0;

	mch = rd->cat[c].mark;
	if
	(
		tolower(str[0])==tolower(mch)
		&&
		(
		  (
			(
				tolower(str[1])==tolower(mch)
				||
				isdigit(str[1])
			)
			&&
			(
				stricmp(str+2,"_START")==0
				||
				stricmp(str+2,"_END")==0
			)
		  )
		  ||
		  (
			stricmp(str+1,"_START")==0
			||
			stricmp(str+1,"_END")==0
		  )
		)
	)
		return 1;
	return 0;
}

void CopyStrIdxAry(StrIdxAry **out,int *nout,StrIdxAry *in,int nin)
{
	int i;

	FreeStrIdxAry(out,nout);
	*nout = nin;
	if (nin)
	{
		*out = (StrIdxAry *)malloc((*nout)*sizeof(StrIdxAry));

		for (i=0;i<*nout;i++)
		{
			(*out)[i].str = (char *)malloc(strlen(in[i].str)+1);

			strcpy((*out)[i].str,in[i].str);
			(*out)[i].lidx = in[i].lidx;
			(*out)[i].didx = in[i].didx;
		}
	}
}

void LocateCategories(WadDir *dir,ResourceDefinition *rd,ResourceDefinition *ord)
{
	int c,b,a,i,rcnt=0;
	char resname[16];


	ord->cat = (Category *)malloc(MAXCAT*sizeof(Category));
	ord->ncats = rd->ncats;
	for (c=0;c<rd->ncats;c++)
	{
	   strcpy(ord->cat[c].secname,rd->cat[c].secname);
	   strcpy(ord->cat[c].defaultdir,rd->cat[c].defaultdir);
	   ord->cat[c].idm = rd->cat[c].idm;
	   ord->cat[c].mark = rd->cat[c].mark;
	   InitStrIdxAry(&ord->cat[c].Extns,&ord->cat[c].nextns);
	   CopyStrIdxAry(&ord->cat[c].Extns,&ord->cat[c].nextns,rd->cat[c].Extns,rd->cat[c].nextns);
	   InitStrIdxAry(&ord->cat[c].Names,&ord->cat[c].nnames);
	   CopyStrIdxAry(&ord->cat[c].Names,&ord->cat[c].nnames,rd->cat[c].Names,rd->cat[c].nnames);
	}

	for (c=0;c<ord->ncats;c++)
	{
		if (ord->cat[c].idm==ID_LISTED)
		{
			fprintf(stderr,"Locating resources listed by section [%s]        \r",ord->cat[c].secname);
			for (i=0;i<ord->cat[c].nnames;i++,rcnt++)
				ord->cat[c].Names[i].didx = IsIn(ord->cat[c].Names[i].str,dir);
		}
		else if (ord->cat[c].idm==ID_MARKED)
		{
			fprintf(stderr,"Locating marked resources in section [%s]        \r",ord->cat[c].secname);
			a = 32767;
			b = -1;
		  	for (i=0;i<dir->nentries;i++)
		  	{
		  		if (IsCategoryMarker(c,Str8(dir->dirp[i].resname),ord))
		  		{
		  			if (a==32767) a = i;
		  			if (i>b) b = i;
		  		}
		  	}
		  	if (a<32767 && b>-1)
		  	{
		  		for (i=a+1;i<b;i++)
		  		{
		  			strcpy(resname,Str8(dir->dirp[i].resname));
		  			if (!IsCategoryMarker(c,resname,ord))
		  			{
		  				ListName(&ord->cat[c],resname);
		  				ord->cat[c].Names[ord->cat[c].nnames-1].didx = i;
		  				rcnt++;
		  			}
				}
			}
		}
	}
	dprintf(logfile,"Resources located: %d                                      \n",rcnt);
}

void DumpResourceDefinition(ResourceDefinition *rd)
{
	int i,j;

	for (i=0;i<rd->ncats;i++)
	{
		dprintf(logfile,"[%s] %8s ",rd->cat[i].secname,rd->cat[i].defaultdir);
		for (j=0;j<rd->cat[i].nextns;j++)
			dprintf(logfile,"%4s ",rd->cat[i].Extns[j].str);
		switch(rd->cat[i].idm)
		{
			case ID_NONE:
				dprintf(logfile,"None\n");
				break;
			case ID_LISTED:
				dprintf(logfile,"Listed\n");
				for (j=0;j<rd->cat[i].nnames;j++)
					dprintf(logfile,"  %8s %4d %4d\n",rd->cat[i].Names[j].str,rd->cat[i].Names[j].didx,rd->cat[i].Names[j].lidx);
				break;
			case ID_MARKED:
				dprintf(logfile,"Marked by %c_START/END\n",rd->cat[i].mark);
				for (j=0;j<rd->cat[i].nnames;j++)
					dprintf(logfile,"  %8s %4d %4d\n",rd->cat[i].Names[j].str,rd->cat[i].Names[j].didx,rd->cat[i].Names[j].lidx);
				break;
			default:
				dprintf(logfile,"Defaulted\n");
				break;
		}

	}
}
