#include "patch.h"

// Open the control files, make the output wad

int statmain(int argc,char **argv)
{
	int i;
	int cleared=0;
	char mapsel[256];

	dprintf(logfile,"\n");

	CopyEnvironmentCLArgs("STAT",argc,argv);
	if (ParseCommandLine(-1,-1))
	{
		FreeCLStrs();
		return 3;
	}

	if (nclfiles<1)
	{
		dprintf(logfile,"\nSTAT.EXE %s by Jim Flynn, Copyright 1996-8  -- Freeware --\n",PATCHER_VERSION);
		dprintf(logfile,"\nReport information about a DOOM, DOOM II, or BOOM wad.\n");
		dprintf(logfile,"\nUsage: STAT [options] wadfile[.wad] [MapNN]\n");
		dprintf(logfile,"\n General options, use SET STAT=options to set defaults:\n");
		dprintf(logfile,"/M - include multiplayer only things in stats\n");
		dprintf(logfile,"/P - pauses output after each levels main screen\n");
		dprintf(logfile,"/F - list additional information about items and secrets\n");
		dprintf(logfile,"/S - just list size and save data\n");
		dprintf(logfile,"/H - list histogram of Things\n");
		dprintf(logfile,"/C - Just show level check data\n");
		dprintf(logfile,"\n See STAT.TXT for details.\n");
						 
		FreeCLStrs();
		return(1);
	}

	cleared=0;
	strcpy(outname,"");
	for (i=0;i<nclopts;i++)
	{
		if (tolower(cloptions[i][0])=='f')
		    OnePageForm=!cloptsense[i];
		else if (tolower(cloptions[i][0])=='p')
			PauseOutput=cloptsense[i];
		else if (tolower(cloptions[i][0])=='m')
			MultiPlayer=cloptsense[i];
		else if (tolower(cloptions[i][0])=='s')
			SaveInfoOnly=cloptsense[i];
		else if (tolower(cloptions[i][0])=='h')
			DoHists=cloptsense[i];
		else if (tolower(cloptions[i][0])=='c')
			CheckOnly=cloptsense[i];
		else dprintf(logfile,"Warn: command line option: %s not understood\n",cloptions[i]);
	}
	strcpy(pwadname,clfiles[0]);
	strcpy(mapsel,"");
	if (nclfiles>1)
		strcpy(mapsel,clfiles[1]);
	FreeCLStrs();

	AddExt(pwadname,".WAD");
	AddExt(defname,".DEF");

	InitCategories(defname,&ResDef);

	pst = fopen(pwadname,"rb");
	if (pst!=NULL)
	{
		fread(&phdr,sizeof(WadHeader),1,pst);
		ReadDir(&phdr,&pdir,pst);

		return StatWad(mapsel);
	}
	return errorlev;
}

