#include "patch.h"

/* Report stats on a level map */

static int secsec[128], **thingcnts=NULL,**cumthgcnts=NULL;
static int *ldtypes=NULL;

void PrintItem(Thing t)
{
	int s;

	s = SectorOf(t.x,t.y);
	dprintf(logfile,"%-16s (%5hd,%-5hd) %4d      %-14s\n",Name(t.typ),t.x,t.y,s,AttrStr(t.attr));
}

void StatMap(char *maptag)
{
 	int i,j,x,y,sd;
	int easy_ammo=0,easy_hits=1,easy_health=0;
	int med_ammo=0,med_hits=1,med_health=0;
	int hard_ammo=0,hard_hits=1,hard_health=0;
	int easy_things=0,med_things=0,hard_things=0;
	int easy_items=0,med_items=0,hard_items=0;
	int easy_st=0,med_st=0,hard_st=0;
	int easy_dm=0,med_dm=0,hard_dm=0;
	int easy_tele=0,med_tele=0,hard_tele=0;
	int easy_save=337,med_save=337,hard_save=337,ty_save=337;
	int flmin=32767,flmax=-32767,cemin=32767,cemax=-32767;
	int tag666used=0;
	int tag667used=0;
	int litemin,litemax;
	int litetot=0;
	int liteff=0,dameff=0,closeff=0,openeff=0;
	int badstyp=0;
	int secrets=0;
	int reds_sec[16],blus_sec[16],yels_sec[16];
	int redc_sec[16],bluc_sec[16],yelc_sec[16];
	int reds_num[16],blus_num[16],yels_num[16];
	int redc_num[16],bluc_num[16],yelc_num[16];
	int nreds=0,nredc=0,nyels=0,nyelc=0,nblus=0,nbluc=0;
	int xpct,ypct,lpct,dpct;
	int numxaligned, numyaligned;
  int bull[8],shll[8],rock[8],cell[8],sk,tot;
	int nltypes=0,nwtrig=0,nstrig=0,ngtrig=0,nmanual=0,nspecial=0;
	int nregln=0,nextln=0,ngenln=0;
	int linbysid[3],Adj2s,v1,v2,v3,v4;
	int rejtot,rejected;


	for (i=0;i<4096;i++)
		thingcnts[0][i]=thingcnts[1][i]=thingcnts[2][i]=0;

	for (j=0;j<16;j++)
	{
		reds_sec[j]=redc_sec[j]=reds_num[j]=redc_num[j]=-1;
		yels_sec[j]=yelc_sec[j]=yels_num[j]=yelc_num[j]=-1;
		blus_sec[j]=bluc_sec[j]=blus_num[j]=bluc_num[j]=-1;
	}
	nreds=nredc=nyels=nyelc=nblus=nbluc=0;

	for (i=0;i<NThings;i++)
	{
		if (!IsStart(Things[i].typ))
			if ((Things[i].attr&16) && !MultiPlayer) continue;

		switch(IsKey(Things[i].typ))
		{
			case 1:
				x = Things[i].x;
				y = Things[i].y;
				reds_sec[nreds] = SectorOf(x,y);
				reds_num[nreds++] = i;
				break;
			case 2:
				x = Things[i].x;
				y = Things[i].y;
				yels_sec[nyels] = SectorOf(x,y);
				yels_num[nyels++] = i;
				break;
			case 3:
				x = Things[i].x;
				y = Things[i].y;
				blus_sec[nblus] = SectorOf(x,y);
				blus_num[nblus++] = i;
				break;
			case 4:
				x = Things[i].x;
				y = Things[i].y;
				redc_sec[nredc] = SectorOf(x,y);
				redc_num[nredc++] = i;
				break;
			case 5:
				x = Things[i].x;
				y = Things[i].y;
				yelc_sec[nyelc] = SectorOf(x,y);
				yelc_num[nyelc++] = i;
				break;
			case 6:
				x = Things[i].x;
				y = Things[i].y;
				bluc_sec[nbluc] = SectorOf(x,y);
				bluc_num[nbluc++] = i;
				break;
			default:
				break;
		}

		if (Things[i].attr&easymask)
		{
			thingcnts[0][Things[i].typ]++;
			easy_ammo += 20*AmmoContent(Things[i]);
			easy_hits += Toughness(Things[i]);
			easy_health += HealthContent(Things[i]);
			if (CountsForSave(Things[i].typ))
				easy_save += 156;
			easy_things++;
			if (IsItem(Things[i].typ)) easy_items++;
		}
		if (Things[i].attr&mediummask)
		{
			thingcnts[1][Things[i].typ]++;
			med_ammo += 10*AmmoContent(Things[i]);
			med_hits += Toughness(Things[i]);
			med_health += HealthContent(Things[i]);
			if (CountsForSave(Things[i].typ))
				med_save += 156;
			med_things++;
			if (IsItem(Things[i].typ)) med_items++;
		}
		if (Things[i].attr&hardmask)
		{
			thingcnts[2][Things[i].typ]++;
			hard_ammo += 10*AmmoContent(Things[i]);
			hard_hits += Toughness(Things[i]);
			hard_health += HealthContent(Things[i]);
			if (CountsForSave(Things[i].typ))
			{
				hard_save += 156;
				ty_save += 156;
			}
			hard_things++;
			if (IsItem(Things[i].typ)) hard_items++;
		}
	}

	flmin=32767;
	flmax=-32767;
	cemin=32767;
	cemax=-32767;
	tag666used=0;
	litemin=255;
	litemax=0;
	litetot=0;
	liteff=0;
	dameff=0;
	closeff=0;
	openeff=0;
	badstyp=0;
	secrets=0;

	for (i=0;i<NSectors;i++)
	{
		litetot += Sectors[i].lite;

		if (Sectors[i].fhgt<flmin) flmin=Sectors[i].fhgt;
		if (Sectors[i].fhgt>flmax) flmax=Sectors[i].fhgt;
		if (Sectors[i].chgt<cemin) cemin=Sectors[i].chgt;
		if (Sectors[i].chgt>cemax) cemax=Sectors[i].chgt;

		if (Sectors[i].lite<litemin) litemin=Sectors[i].lite;
		if (Sectors[i].lite>litemax) litemax=Sectors[i].lite;

		if (Sectors[i].tag==666) tag666used=1;
		if (Sectors[i].tag==667) tag667used=1;

		switch(Sectors[i].typ)
		{
			case 1:
				liteff++;
				break;
			case 2:
				liteff++;
				break;
			case 3:
				liteff++;
				break;
			case 4:
				liteff++;
				dameff++;
				break;
			case 5:
				dameff++;
				break;
			case 7:
				dameff++;
				break;
			case 8:
				break;
			case 9:
				secsec[secrets++] = i;
				break;
			case 10:
				closeff++;
				break;
			case 11:
				dameff++;
				break;
			case 12:
				liteff++;
				break;
				liteff++;
			case 14:
				openeff++;
				break;
			case 16:
				dameff++;
				break;
			case 17:
				liteff++;
				break;
			default:
				badstyp++;
				break;
		}
	}
    lpct = NSectors? .5 + (liteff*100.0)/NSectors : 0;
    dpct = NSectors? .5 + (dameff*100.0)/NSectors : 0;

	easy_st=med_st=hard_st=0;
	for (i=1;i<=4;i++)
		if (thingcnts[0][i]) easy_st++; else break;
	for (i=1;i<=4;i++)
		if (thingcnts[1][i]) med_st++; else break;
	for (i=1;i<=4;i++)
		if (thingcnts[2][i]) hard_st++; else break;
	easy_dm=thingcnts[0][11];
	med_dm=thingcnts[1][11];
	hard_dm=thingcnts[2][11];
    easy_tele=thingcnts[0][14];
    med_tele=thingcnts[1][14];
    hard_tele=thingcnts[2][14];

    for (sk=0;sk<3;sk++)
    {
        bull[sk] = (thingcnts[sk][3004] * 5 + (thingcnts[sk][2007]+thingcnts[sk][8]) * 10 + thingcnts[sk][2048] * 50);
        if (!sk) bull[sk] *= 2;

        shll[sk] = (thingcnts[sk][9] * 4 + thingcnts[sk][2008] * 8 +thingcnts[sk][8] * 4 + thingcnts[sk][2049] * 20);
        if (!sk) shll[sk] *= 2;

        rock[sk] = thingcnts[sk][2046] * 5;
        if (!sk) rock[sk] *= 2;
        rock[sk] += thingcnts[sk][2010] + thingcnts[sk][8];

        cell[sk] = (thingcnts[sk][17] * 100 + (thingcnts[sk][2047]+thingcnts[sk][8]) * 20);
        if (!sk) cell[sk] *= 2;
    }
    bull[3] = bull[2]*1;
    shll[3] = shll[2]*7;
    rock[3] = rock[2]*20;
    cell[3] = cell[2]*2;

	for (i=0;i<3;i++)
		linbysid[i]=0;
	Adj2s=0;

	ldtypes = (int *)malloc(65536*sizeof(int));
	memset(ldtypes,0,65536*sizeof(int));
	nltypes=nstrig=nwtrig=ngtrig=0;

	for (i=0;i<NLinedefs;i++)
	{
		sd=0;
		if (Linedefs[i].sides[0]!=-1) sd++;
		if (Linedefs[i].sides[1]!=-1) sd++;
		linbysid[sd]++;
		v1 = Linedefs[i].to;
		v2 = Linedefs[i].from;
		if (SaveInfoOnly && sd==2)
		{
			for (j=0;j<NLinedefs;j++)
			{
				if (Linedefs[j].sides[0]>=0 && Linedefs[j].sides[1]<0)
				{
					v1 = Linedefs[i].to;
					v2 = Linedefs[i].from;
					v3 = Linedefs[j].to;
					v4 = Linedefs[j].from;
					if (v1==v3 || v1==v4 || v2==v3 || v2==v4)
						break;
				}
			}
			if (j==NLinedefs) Adj2s++;
		}


		ldtypes[(Linedefs[i].typ)&65535]++;
		if (ldtypes[(Linedefs[i].typ)&65535]==1)
			nltypes++;
		if (0<Linedefs[i].typ && Linedefs[i].typ<nldtrigs)
		{
			switch (ldtrigs[Linedefs[i].typ])
			{
				case SW:
					nstrig++;
					break;
				case WA:
					nwtrig++;
					break;
				case GU:
					ngtrig++;
					break;
				case MA:
					nmanual++;
					break;
				case NU:
					nspecial++;
					break;
				default:
					break;
			}
			if (Linedefs[i].typ==78 || Linedefs[i].typ==85 || Linedefs[i].typ>141)
				nextln++;
			else
				nregln++;
		}
		else if (0x2f80<=Linedefs[i].typ && ((unsigned)Linedefs[i].typ)<0x8000)
		{
			ngenln++;
			switch((Linedefs[i].typ&7)>>1)
			{
				case 0:
					nwtrig++;
					break;
				case 1:
					nstrig++;
					break;
				case 2:
					ngtrig++;
					break;
				case 3:
					nmanual++;
					break;
				default:
					break;
			}
		}
	}
	free(ldtypes);

	numxaligned=0;
	numyaligned=0;
	for (i=0;i<NSidedefs;i++)
	{
		if (Sidedefs[i].xoff) numxaligned++;
		if (Sidedefs[i].yoff) numyaligned++;
	}
	xpct = NSidedefs? (100.0*numxaligned)/NSidedefs : 0;
	ypct = NSidedefs? (100.0*numyaligned)/NSidedefs : 0;

	GetMapLimits();
	if (!CheckOnly && !SaveInfoOnly && !DoHists)
	{
    	dprintf(logfile,"                             -monsters-\n");
    	dprintf(logfile,"  Tro Sar Com Wol Imp Dem Spe Sou Cac Ele Kni Bar Man Rev Ara Vil Cyb Spi Icon\n");
    	dprintf(logfile,"E ");
    	for (i=TRO;i<BRA;i++)
        	dprintf(logfile,"%-4d",thingcnts[0][monst_iter[i]]);
    	dprintf(logfile,"%1d/%1d/%1d\nM ",thingcnts[0][monst_iter[BRA]],thingcnts[0][monst_iter[SSH]],thingcnts[0][monst_iter[SPN]]);
    	for (i=TRO;i<BRA;i++)
        	dprintf(logfile,"%-4d",thingcnts[1][monst_iter[i]]);
    	dprintf(logfile,"%1d/%1d/%1d\nH ",thingcnts[1][monst_iter[BRA]],thingcnts[1][monst_iter[SSH]],thingcnts[1][monst_iter[SPN]]);
    	for (i=TRO;i<BRA;i++)
        	dprintf(logfile,"%-4d",thingcnts[2][monst_iter[i]]);
    	dprintf(logfile,"%1d/%1d/%1d\n ",thingcnts[2][monst_iter[BRA]],thingcnts[2][monst_iter[SSH]],thingcnts[2][monst_iter[SPN]]);
    	dprintf(logfile,"          -health-                   -armor-                -ammo-\n");
    	dprintf(logfile,"  Bot Sti Med Bsk Blu Meg Total| Hlm Grn Blu Total| Bull Shel Rock Cell Total\n");
    	dprintf(logfile,"E");
    	for (i=BOT,tot=0;i<=MEG;i++)
    	{
        	dprintf(logfile,"%4d",thingcnts[0][health_iter[i]]);
        	tot += thingcnts[0][health_iter[i]]*HealthCont(health_iter[i]);
    	}
    	dprintf(logfile," %5d|",tot);
    	for (i=HLM,tot=0;i<=BLA;i++)
    	{
        	dprintf(logfile,"%4d",thingcnts[0][armour_iter[i]]);
        	tot += thingcnts[0][armour_iter[i]]*ArmourCont(armour_iter[i]);
    	}
    	tot += thingcnts[0][83]*200;
    	dprintf(logfile," %5d|",tot);
    	dprintf(logfile," %4d %4d %4d %4d",bull[0],shll[0],rock[0],cell[0]);
    	tot = bull[0]+7*shll[0]+20*rock[0]+2*cell[0];
    	dprintf(logfile," %5d",tot);
    	dprintf(logfile,"\nM");
    	for (i=BOT,tot=0;i<=MEG;i++)
    	{
        	dprintf(logfile,"%4d",thingcnts[1][health_iter[i]]);
        	tot += thingcnts[1][health_iter[i]]*HealthCont(health_iter[i]);
    	}
    	dprintf(logfile," %5d|",tot);
    	for (i=HLM,tot=0;i<=BLA;i++)
    	{
        	dprintf(logfile,"%4d",thingcnts[1][armour_iter[i]]);
        	tot += thingcnts[1][armour_iter[i]]*ArmourCont(armour_iter[i]);
    	}
    	tot += thingcnts[1][83]*200;
    	dprintf(logfile," %5d|",tot);
    	dprintf(logfile," %4d %4d %4d %4d",bull[1],shll[1],rock[1],cell[1]);
    	tot = bull[1]+7*shll[1]+20*rock[1]+2*cell[1];
    	dprintf(logfile," %5d",tot);
    	dprintf(logfile,"\nH");
    	for (i=BOT,tot=0;i<=MEG;i++)
    	{
        	dprintf(logfile,"%4d",thingcnts[2][health_iter[i]]);
        	tot += thingcnts[2][health_iter[i]]*HealthCont(health_iter[i]);
    	}			   
    	dprintf(logfile," %5d|",tot);
    	for (i=HLM,tot=0;i<=BLA;i++)
    	{
        	dprintf(logfile,"%4d",thingcnts[2][armour_iter[i]]);
        	tot += thingcnts[2][armour_iter[i]]*ArmourCont(armour_iter[i]);
    	}
    	tot += thingcnts[2][83]*200;
    	dprintf(logfile," %5d|",tot);
    	dprintf(logfile," %4d %4d %4d %4d",bull[2],shll[2],rock[2],cell[2]);
    	tot = bull[2]+7*shll[2]+20*rock[2]+2*cell[2];
    	dprintf(logfile," %5d\n",tot);
	}

	easy_save += 12*NSectors+16*linbysid[1]+28*linbysid[2];
	med_save += 12*NSectors+16*linbysid[1]+28*linbysid[2];
	hard_save += 12*NSectors+16*linbysid[1]+28*linbysid[2];
	ty_save += 16*linbysid[1] + 12*linbysid[2] + 40*NSectors;

	rejected = 0;
	for (i=0;i<NReject;i++)
	{
		rejected += bitcnt[(unsigned)(Reject[i])];
	}
	rejtot = NSectors*NSectors;

	if (SaveInfoOnly)
	{
		dprintf(logfile,"Thg:%5d  Vrt:%5d  Ldf:%5d  Sdf:%5d  Sct:%5d  L0:%4d L1:%4d L2:%4d\n",NThings,NVertexes,NLinedefs,NSidedefs,NSectors,linbysid[0],linbysid[1],linbysid[2]);
		dprintf(logfile,"Ty est: %6d  Jim est: %6d\n",ty_save,hard_save);
	}
	else if (CheckOnly)
	{
		dprintf(logfile,"Starts: %d/%d/%d\n",easy_st,med_st,hard_st);
		dprintf(logfile,"Rejected: %d%%\n",rejtot? (rejected*100)/rejtot : 0);
		dprintf(logfile,"Save est.: %d\n",hard_save);
	}
	else if (!DoHists)
	{
    	dprintf(logfile,"           -weapons-                  -quantities-           -balance-\n");
    	dprintf(logfile,"  Sho Chg Dbs Rpg Plr Bfg Chs Brl| Thg Itm Tel Sta Dms|  M/H   A/M | Saves\n");
    	dprintf(logfile,"E");
    	for (i=SHO,tot=0;i<=BRL;i++)
        	dprintf(logfile,"%4d",thingcnts[0][weap_iter[i]]);
    	dprintf(logfile,"|%4d",easy_things);
    	dprintf(logfile,"%4d",easy_items);
    	dprintf(logfile,"%4d",easy_tele);
    	dprintf(logfile,"%4d",easy_st);
    	dprintf(logfile,"%4d",easy_dm);
    	dprintf(logfile,"|");
    	dprintf(logfile,"%6.2lf",easy_health? easy_hits/(1.0*easy_health) : 0);
    	dprintf(logfile,"%6.2lf",easy_hits? (1.0*easy_ammo)/easy_hits : 0);
		dprintf(logfile,"| %6d\n",easy_save);
    	dprintf(logfile,"M");
    	for (i=SHO,tot=0;i<=BRL;i++)
        	dprintf(logfile,"%4d",thingcnts[1][weap_iter[i]]);
    	dprintf(logfile,"|%4d",med_things);
    	dprintf(logfile,"%4d",med_items);
    	dprintf(logfile,"%4d",med_tele);
    	dprintf(logfile,"%4d",med_st);
    	dprintf(logfile,"%4d",med_dm);
    	dprintf(logfile,"|");
    	dprintf(logfile,"%6.2lf",med_health? med_hits/(1.0*med_health) : 0);
    	dprintf(logfile,"%6.2lf",med_hits? (1.0*med_ammo)/med_hits : 0);
		dprintf(logfile,"| %6d\n",med_save);
    	dprintf(logfile,"H");
    	for (i=SHO,tot=0;i<=BRL;i++)
        	dprintf(logfile,"%4d",thingcnts[2][weap_iter[i]]);
    	dprintf(logfile,"|%4d",hard_things);
    	dprintf(logfile,"%4d",hard_items);
    	dprintf(logfile,"%4d",hard_tele);
    	dprintf(logfile,"%4d",hard_st);
    	dprintf(logfile,"%4d",hard_dm);
    	dprintf(logfile,"|");
    	dprintf(logfile,"%6.2lf",hard_health? hard_hits/(1.0*hard_health) : 0);
    	dprintf(logfile,"%6.2lf",hard_hits? (1.0*hard_ammo)/hard_hits : 0);
		dprintf(logfile,"| %6d\n",hard_save);

		dprintf(logfile,"\nx-aligned:%3d%%   y-aligned:%3d%%   Lighting: %3d /%3d%%  Damage: %3d /%3d%%\n",xpct,ypct,liteff,lpct,dameff,dpct);
		dprintf(logfile,"Trg kind:%3d Wlk:%3d Swi:%3d Gun:%3d Man:%3d Spec:%3d Reg:%3d Ext:%3d Gen:%3d\n",
			     nltypes,nwtrig,nstrig,ngtrig,nmanual,nspecial,nregln,nextln,ngenln);
		dprintf(logfile,"X: %5d to %5d  Y: %5d to %5d  Z: %5d to %5d\n",map_minx,map_maxx,map_miny,map_maxy,flmin,cemax);
		dprintf(logfile,"Thg:%5d Vrt:%5d Ldf:%5d Sdf:%5d Sct:%5d Nod:%5d Seg:%5d Ssc:%5d\n",NThings,NVertexes,NLinedefs,NSidedefs,NSectors,NNodes,NSegs,NSsectors);
   	dprintf(logfile,"Keys: RS:%d  RC:%d  YS:%d  YC:%d  BS:%d  BC:%d            Blkmap: %5XH  Reject: %2d%%\n",nreds,nredc,nyels,nyelc,nblus,nbluc,NBlockmap,rejtot? (rejected*100)/rejtot : 0);
	}

	if (SaveInfoOnly) return;
	if (CheckOnly) return;
	if (PauseOutput) WaitKey();

	if (!OnePageForm && !DoHists)
	{
		dprintf(logfile,"%d Secret Sectors",secrets);
		if (secrets)
		{
			dprintf(logfile,": %d",secsec[0]);
			for (i=1;i<secrets;i++)
				dprintf(logfile,",%d",secsec[i]);
			dprintf(logfile,"\n");
		}
		else dprintf(logfile,"\n");
		dprintf(logfile,"\n");

		dprintf(logfile,"Item# Description      Posn           Sector   Presence\n");
		for (i=0;i<NThings;i++)
			if (IsItem(Things[i].typ))
			{
				dprintf(logfile,"%4d: ",i);
				PrintItem(Things[i]);
			}
		dprintf(logfile,"\n");

		dprintf(logfile,"Weap# Description      Posn           Sector   Presence\n");
		for (i=0;i<NThings;i++)
			if (IsWeapon(Things[i].typ))
			{
				dprintf(logfile,"%4d: ",i);
				PrintItem(Things[i]);
			}
		dprintf(logfile,"\n");

		dprintf(logfile,"Armr# Description      Posn           Sector   Presence\n");
		for (i=0;i<NThings;i++)
			if (IsArmor(Things[i].typ))
			{
				dprintf(logfile,"%4d: ",i);
				PrintItem(Things[i]);
			}
		dprintf(logfile,"\n");

		dprintf(logfile,"Hlth# Description      Posn           Sector   Presence\n");
		for (i=0;i<NThings;i++)
			if (IsHealth(Things[i].typ))
			{
				dprintf(logfile,"%4d: ",i);
				PrintItem(Things[i]);
			}
		dprintf(logfile,"\n");

		dprintf(logfile,"Boss# Description      Posn           Sector   Presence\n");
		for (i=0;i<NThings;i++)
			if (IsBoss(Things[i].typ))
			{
				dprintf(logfile,"%4d: ",i);
				PrintItem(Things[i]);
			}
		dprintf(logfile,"\n");

		if (nreds>0)
		{
			dprintf(logfile,"%d red skull key(s):      ",nreds);
			for (j=0;j<nreds;j++)
			{
				dprintf(logfile,"%-5d@(%5hd,%-5hd)\n",
					reds_sec[j],Things[reds_num[j]].x,Things[reds_num[j]].y);
				if (j<nreds-1) dprintf(logfile,",");
			}
		} else dprintf(logfile,"No red skull key\n");

		if (nyels>0)
		{
			dprintf(logfile,"%d yellow skull key(s):   ",nyels);
			for (j=0;j<nyels;j++)
			{
				dprintf(logfile,"%-5d@(%5hd,%-5hd)\n",
					yels_sec[j],Things[yels_num[j]].x,Things[yels_num[j]].y);
				if (j<nyels-1) dprintf(logfile,",");
			}
		} else dprintf(logfile,"No yellow skull key\n");

		if (nblus>0)
		{
			dprintf(logfile,"%d blue skull key(s):     ",nblus);
			for (j=0;j<nblus;j++)
			{
				dprintf(logfile,"%-5d@(%5hd,%-5hd)\n",
					blus_sec[j],Things[blus_num[j]].x,Things[blus_num[j]].y);
				if (j<nblus-1) dprintf(logfile,",");
			}
		} else dprintf(logfile,"No blue skull key\n");

		if (nredc>0)
		{
			dprintf(logfile,"%d red key card(s):       ",nredc);
			for (j=0;j<nredc;j++)
			{
				dprintf(logfile,"%-5d@(%5hd,%-5hd)\n",
					redc_sec[j],Things[redc_num[j]].x,Things[redc_num[j]].y);
				if (j<nredc-1) dprintf(logfile,",");
			}
			dprintf(logfile,"\n");
		} else dprintf(logfile,"No red key card\n");

		if (nyelc>0)
		{
			dprintf(logfile,"%d yellow key card(s):    ",nyelc);
			for (j=0;j<nyelc;j++)
			{
				dprintf(logfile,"%-5d@(%5hd,%-5hd)\n",
					yelc_sec[j],Things[yelc_num[j]].x,Things[yelc_num[j]].y);
				if (j<nyelc-1) dprintf(logfile,",");
			}
			dprintf(logfile,"\n");
		} else dprintf(logfile,"No yellow key card\n");

		if (nbluc>0)
		{
			dprintf(logfile,"%d blue key card(s):      ",nbluc);
			for (j=0;j<nbluc;j++)
			{
				dprintf(logfile,"%-5d@(%5hd,%-5hd)\n",
					bluc_sec[j],Things[bluc_num[j]].x,Things[bluc_num[j]].y);
				if (j<nbluc-1) dprintf(logfile,",");
			}
			dprintf(logfile,"\n");
		} else dprintf(logfile,"No blue key card\n");
		dprintf(logfile,"\n");

		dprintf(logfile,"Close/Open (types 10/14) sector effect used: %s\n",(openeff|closeff)? "Yes" : "No");
		dprintf(logfile,"Lower at end tag 666 found: %s\n",tag666used? "Yes" : "No");
		dprintf(logfile,"Raise at end tag 667 found: %s\n\n",tag667used? "Yes" : "No");

	}

	if (DoHists)
	{
		dprintf(logfile,"\nHistogram of things over level %s\n",maptag);
		for (i=0;i<4096;i++)
		{
			if (i>0 && i<90)
				dprintf(logfile,"%-4d: %-24s %4d %4d %4d\n",i,Name(i),thingcnts[0][i],thingcnts[1][i],thingcnts[2][i]);
			else if (i>2000 && i<2050)
				dprintf(logfile,"%-4d: %-24s %4d %4d %4d\n",i,Name(i),thingcnts[0][i],thingcnts[1][i],thingcnts[2][i]);
			else if (i>3000 && i<3007)
				dprintf(logfile,"%-4d: %-24s %4d %4d %4d\n",i,Name(i),thingcnts[0][i],thingcnts[1][i],thingcnts[2][i]);
			else if (thingcnts[0][i]+thingcnts[1][i]+thingcnts[2][i])
				dprintf(logfile,"%-4d: %-24s %4d %4d %4d\n",i,"Unknown",thingcnts[0][i],thingcnts[1][i],thingcnts[2][i]);
		}
	}
}

/* Report stats on each level in a wad */

int StatWad(char *mapsel)
{
	int i,j,c;
	Category *ctgy;

	thingcnts = malloc(3*sizeof(char *));
	cumthgcnts = malloc(3*sizeof(char *));
	for (i=0;i<3;i++)
	{
		thingcnts[i] = malloc(4096*sizeof(int));
		cumthgcnts[i] = malloc(4096*sizeof(int));
	}

	if (DoHists)
		for (i=0;i<4096;i++)
			cumthgcnts[0][i]=cumthgcnts[1][i]=cumthgcnts[2][i]=0;

	c = CategoryOf("LEVELS",&ResDef);
	if (c>=0)
	{
		ctgy = ResDef.cat+c;
		for (i=0;i<ctgy->nnames;i++)
		{
        	if (!*mapsel || stricmp(mapsel,ctgy->Names[i].str)==0)
        	{
				if (!ReadLevelData(ctgy->Names[i].str,&pdir,pst,NLevObj()))
				{
					if (!SaveInfoOnly)
					{
		    			dprintf(logfile,"Analyzing Level %s:                                         ",
							ctgy->Names[i].str);
		    			dprintf(logfile," %s\n",MultiPlayer? "(Multiplayer)" : "(Single Player)");
					}

		    		StatMap(ctgy->Names[i].str);
					FreeLevelData();

					if (!SaveInfoOnly)
			    		if (i<ctgy->nnames-1) dprintf(logfile,"\n");
					if (DoHists)
					{
						for (j=0;j<4096;j++)
						{
							cumthgcnts[0][j] += thingcnts[0][j];
							cumthgcnts[1][j] += thingcnts[1][j];
							cumthgcnts[2][j] += thingcnts[2][j];
						}
					}
				}
        	}
		}
	}

	if (!*mapsel && DoHists)
	{
		dprintf(logfile,"\nHistogram of things over all levels\n");
		for (i=0;i<4096;i++)
		{
			if (i>0 && i<90)
				dprintf(logfile,"%-4d: %-24s %4d %4d %4d\n",i,Name(i),cumthgcnts[0][i],cumthgcnts[1][i],cumthgcnts[2][i]);
			else if (i>2000 && i<2050)
				dprintf(logfile,"%-4d: %-24s %4d %4d %4d\n",i,Name(i),cumthgcnts[0][i],cumthgcnts[1][i],cumthgcnts[2][i]);
			else if (i>3000 && i<3007)
				dprintf(logfile,"%-4d: %-24s %4d %4d %4d\n",i,Name(i),cumthgcnts[0][i],cumthgcnts[1][i],cumthgcnts[2][i]);
			else if (cumthgcnts[0][i]+cumthgcnts[1][i]+cumthgcnts[2][i])
				dprintf(logfile,"%-4d: %-24s %4d %4d %4d\n",i,"Unknown",cumthgcnts[0][i],cumthgcnts[1][i],cumthgcnts[2][i]);
		}
	}

	for (i=0;i<3;i++)
	{
		free(thingcnts[i]);
		free(cumthgcnts[i]);
	}
	free(thingcnts);
	thingcnts=NULL;
	free(cumthgcnts);
	cumthgcnts=NULL;
	return 0;
}

