#include "patch.h"

int DoMap[100];

void FreeStuckStructures()
{
	FreeDir(&pdir);
	FreeResourceDefinition(&ResDef);
	CloseStreams();
}

// Open the control files, make the output wad

int stucmain(int argc,char **argv)
{
	int i,j,m,n;
	int cleared=0;
	char mapsel[256],*q;

	dprintf(logfile,"\n");

	CopyEnvironmentCLArgs("STUCK",argc,argv);
	if (ParseCommandLine(-1,-1))
	{
		FreeCLStrs();
		return 3;
	}

	if (!nclfiles)
	{
		dprintf(logfile,"\nSTUCK %s by Jim Flynn, Copyright 1996-7  -- Freeware --\n",PATCHER_VERSION);
		dprintf(logfile,"\nReport things in a DOOM II wad for poor placement\n");
		dprintf(logfile,"\nUsage: STUCK [options] wadfile[.wad] [Mapnn[-mm]]...\n");
		dprintf(logfile,"\n Test selection option:\n");
		dprintf(logfile," +XYZ does only XYZ tests, -XYZ does all BUT XYZ tests.\n");
		dprintf(logfile," T TOGETHER   E EDGE\n");
		dprintf(logfile," W WALLS      C CEILING\n");
		dprintf(logfile,"\n General options, use SET STUCK=options to set defaults:\n");
		dprintf(logfile,"/M - include multiplayer only things in tests\n");
		dprintf(logfile,"/A - include all things, not just monsters\n");
		dprintf(logfile,"\n See STUCK.TXT for details.\n");
						 
		FreeCLStrs();
		return(1);
	}

	MonstersOnly=1;
	MultiPlayer=0;
	TogetherTest=WallTest=EdgeTest=CeilingTest=1;
	for (i=0;i<nclopts;i++)
	{
		n = strspn(cloptions[i],"wtecWTEC");
		if (n==strlen(cloptions[i]))
		{
			if (!cleared)	// if first selection option
			{
				if (cloptsense[i])	// clear all if it adds types
				{
					TogetherTest=WallTest=CeilingTest=EdgeTest=0;
				}
				else if (!cloptsense[i]) // set all if it subtracts types
				{
					TogetherTest=WallTest=CeilingTest=EdgeTest=1;
				}
				cleared=1;	// but don't do it for following selection opts
			}
			for (j=0;j<strlen(cloptions[i]);j++)
			{
				switch(tolower(cloptions[i][j]))
				{
					case 'w':
						WallTest = cloptsense[i];
						break;
					case 't':
						TogetherTest = cloptsense[i];
						break;
					case 'e':
						EdgeTest = cloptsense[i];
						break;
					case 'c':
						CeilingTest = cloptsense[i];
						break;
				}
			}
		}
		else if (tolower(cloptions[i][0])=='a')
			MonstersOnly=!cloptsense[i];
		else if (tolower(cloptions[i][0])=='m')
			MultiPlayer=cloptsense[i];
		else printf("\nWarn: command line option not understood: %s\n",cloptions[i]);
	}

	ReadExternalThingData("");

	strcpy(pwadname,clfiles[0]);
	AddExt(pwadname,".WAD");
	AddExt(defname,".DEF");

	InitCategories(defname,&ResDef);

	for (i=1;i<=32;i++)
		DoMap[i] = 1;
	cleared=0;
	for (i=1;i<nclfiles;i++)
		if (strnicmp("MAP",clfiles[i],3)==0)
		{
			q = strchr(clfiles[i],'-');			// check for range: Map1-13
			if (q) *q='\0';
			if (NumsOnly(clfiles[i]+3))			// insure range is numeric
				if (!q || NumsOnly(q+1))
				{
					if (!cleared)
						for (j=1;j<=32;j++)		// if maps specified do those given
							DoMap[j] = 0;		// otherwise default to do all
					cleared=1;

					n = atoi(clfiles[i]+3);		// get map number
					m = q? atoi(q+1) : n;

					for (j=n;j<=m;j++)
						if (1<=j && j<=32)
							DoMap[j]=1;			// if in range, add it to list
						else
							dprintf(logfile,"WARNING: %s not a valid Map for DOOM II\n",clfiles[i]);
				}
		}

	FreeCLStrs();

	pst = fopen(pwadname,"rb");
	if (pst!=NULL)
	{
		fread(&phdr,sizeof(WadHeader),1,pst);
		ReadDir(&phdr,&pdir,pst);

		for (i=1;i<=32;i++)
		{
			sprintf(mapsel,"MAP%02d",i);
			if (IsIn(mapsel,&pdir)>=0 && DoMap[i])
			{
				dprintf(logfile,"\nChecking level %s for misplaced things in ", mapsel);
				dprintf(logfile," %s\n\n",MultiPlayer? "Multiplayer" : "Single Player");
				CheckMap(mapsel,&pdir,pst);
			}
		}
		dprintf(logfile,"\n");
	}

	//FreeStuckStructures();
	return errorlev;
}

