#include "patch.h"

static struct _dosdate_t ddate;
static struct _dostime_t dtime;
static char timstr[64],datstr[64];
static char daystr[64],yrstr[64];
static char allstr[64];
static unsigned timenow;

static char *ampm[]={"AM","PM"};
static char *Days[]={"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};
static char *Months[]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};

void StartTimer(Timer *tmr,int per)
{
	tmr->time0 = timenow;
	tmr->period = per;
	tmr->expf = 0;
}

int CheckTimer(Timer *tmr)
{
	UpdateTime();
	if (!tmr->expf)
	{
		if (timenow<tmr->time0)
		{
			if (timenow+86400000-tmr->time0>=tmr->period)
				tmr->expf = 1;
		}
		else
		{
			if (timenow-tmr->time0>=tmr->period)
				tmr->expf = 1;
		}
	}
	return tmr->expf;
}

char *FormatTime()
{

	int ma,hr;

	ma = (dtime.hour>=12)? 1 : 0;
	hr = (dtime.hour>=13)? dtime.hour-12 : dtime.hour;
	if (!hr) hr=12;
	sprintf(timstr,"%2.2d:%2.2d %s",hr,dtime.minute,ampm[ma]);
	sprintf(daystr,"%s",Days[ddate.dayofweek]);
	sprintf(datstr,"%s %d",Months[ddate.month-1],ddate.day);
	sprintf(yrstr,"%d",ddate.year);
	sprintf(allstr,"%s %s %s, %s",timstr,daystr,datstr,yrstr);
	return allstr;
}

void UpdateTime()
{
	_dos_getdate(&ddate);
	_dos_gettime(&dtime);
	timenow = dtime.hour*360000L + dtime.minute*6000L + dtime.second*100L + dtime.hsecond;
}



char *GetDateTime()
{
	UpdateTime();
	return FormatTime();
}


