#include "patch.h"
#include <crt0.h>

static int *DoMap;
static char *txtures=NULL;
static char *wilds=NULL;
static int *txttotcnt=NULL;
static int *txtuprcnt=NULL;
static int *txt1Sncnt=NULL;
static int *txt2Sncnt=NULL;
static int *txtlwrcnt=NULL;
static int *txtlenmax=NULL;
static int *txtlenmin=NULL;
static int *txthgtmax=NULL;
static int *txthgtmin=NULL;
static int *txtxoffmax=NULL;
static int *txtxoffmin=NULL;
static int *txtyoffmax=NULL;
static int *txtyoffmin=NULL;
static int *alltotcnt=NULL;
static int *alluprcnt=NULL;
static int *all1Sncnt=NULL;
static int *all2Sncnt=NULL;
static int *alllwrcnt=NULL;
static int *alllenmax=NULL;
static int *alllenmin=NULL;
static int *allhgtmax=NULL;
static int *allhgtmin=NULL;
static int *allxoffmax=NULL;
static int *allxoffmin=NULL;
static int *allyoffmax=NULL;
static int *allyoffmin=NULL;
static short *ptchwid=NULL;
static short *ptchhgt=NULL;
static short *ptchxo=NULL;
static short *ptchyo=NULL;
static int ntxtures=0;
static int nwilds=0;
static short *lndf=NULL;
static int detailhdrdone=0;


static int DoDetails=1;
static int DoSummary=1;
static int DoTotals=1;
static int DoBlanks=0;
static int ResolveTextures=0;
static int UseInternalTextures=0;
static int DoSwitches=0;
static int DoAnimated=0;
static int DoSingles=0;
static int Clear1SUL=0;

// disable wildcard expansion on command line

char **__crt0_glob_function(char *_argument)
{
	return NULL;
}

static void InitMapHist()
{
	int i;

	memset(txttotcnt,0,2048*sizeof(int));
	memset(txtuprcnt,0,2048*sizeof(int));
	memset(txt1Sncnt,0,2048*sizeof(int));
	memset(txt2Sncnt,0,2048*sizeof(int));
	memset(txtlwrcnt,0,2048*sizeof(int));
	for (i=0;i<2048;i++)
	{
		txtlenmax[i]=-32767;
		txthgtmax[i]=-32767;
		txtxoffmax[i]=-32767;
		txtyoffmax[i]=-32767;
		txtlenmin[i]=32767;
		txthgtmin[i]=32767;
		txtxoffmin[i]=32767;
		txtyoffmin[i]=32767;
	}
}

void InitHist()
{
	DoMap = NULL;
	txtures = NULL;
	wilds = NULL;
	txttotcnt = NULL;
	txtuprcnt = NULL;
	txt1Sncnt = NULL;
	txt2Sncnt = NULL;
	txtlwrcnt = NULL;
	txtlenmax = NULL;
	txtlenmin = NULL;
	txthgtmax = NULL;
	txthgtmin = NULL;
	txtxoffmax = NULL;
	txtxoffmin = NULL;
	txtyoffmax = NULL;
	txtyoffmin = NULL;
	alltotcnt = NULL;
	alluprcnt = NULL;
	all1Sncnt = NULL;
	all2Sncnt = NULL;
	alllwrcnt = NULL;
	alllenmax = NULL;
	alllenmin = NULL;
	allhgtmax = NULL;
	allhgtmin = NULL;
	allxoffmax = NULL;
	allxoffmin = NULL;
	allyoffmax = NULL;
	allyoffmin = NULL;
	ptchwid = NULL;
	ptchhgt = NULL;
	ptchxo = NULL;
	ptchyo = NULL;
	lndf = NULL;
	detailhdrdone=0;
	ntxtures=0;
	nwilds=0;
}

static void AllocHist()
{
	int i;

	DoMap = (int *)malloc(100*sizeof(int));
	txtures = (char *)malloc(32776*sizeof(char));
	wilds = (char *)malloc(1032*sizeof(char));
	txttotcnt = (int *)malloc(2048*sizeof(int));
	txtuprcnt = (int *)malloc(2048*sizeof(int));
	txt1Sncnt = (int *)malloc(2048*sizeof(int));
	txt2Sncnt = (int *)malloc(2048*sizeof(int));
	txtlwrcnt = (int *)malloc(2048*sizeof(int));
	txtlenmax = (int *)malloc(2048*sizeof(int));
	txtlenmin = (int *)malloc(2048*sizeof(int));
	txthgtmax = (int *)malloc(2048*sizeof(int));
	txthgtmin = (int *)malloc(2048*sizeof(int));
	txtxoffmax = (int *)malloc(2048*sizeof(int));
	txtxoffmin = (int *)malloc(2048*sizeof(int));
	txtyoffmax = (int *)malloc(2048*sizeof(int));
	txtyoffmin = (int *)malloc(2048*sizeof(int));
	alltotcnt = (int *)malloc(2048*sizeof(int));
	alluprcnt = (int *)malloc(2048*sizeof(int));
	all1Sncnt = (int *)malloc(2048*sizeof(int));
	all2Sncnt = (int *)malloc(2048*sizeof(int));
	alllwrcnt = (int *)malloc(2048*sizeof(int));
	alllenmax = (int *)malloc(2048*sizeof(int));
	alllenmin = (int *)malloc(2048*sizeof(int));
	allhgtmax = (int *)malloc(2048*sizeof(int));
	allhgtmin = (int *)malloc(2048*sizeof(int));
	allxoffmax = (int *)malloc(2048*sizeof(int));
	allxoffmin = (int *)malloc(2048*sizeof(int));
	allyoffmax = (int *)malloc(2048*sizeof(int));
	allyoffmin = (int *)malloc(2048*sizeof(int));
	ptchwid = (short *)malloc(4096*sizeof(int));
	ptchhgt = (short *)malloc(4096*sizeof(int));
	ptchxo = (short *)malloc(4096*sizeof(int));
	ptchyo = (short *)malloc(4096*sizeof(int));
	lndf = (short *)malloc(16384*sizeof(short));

	memset(txtures,0,4096);
	memset(wilds,0,1024);
	memset(alltotcnt,0,2048*sizeof(int));
	memset(alluprcnt,0,2048*sizeof(int));
	memset(all1Sncnt,0,2048*sizeof(int));
	memset(all2Sncnt,0,2048*sizeof(int));
	memset(alllwrcnt,0,2048*sizeof(int));
	for (i=0;i<2048;i++)
	{
		alllenmax[i]=-32767;
		allhgtmax[i]=-32767;
		allxoffmax[i]=-32767;
		allyoffmax[i]=-32767;
		alllenmin[i]=32767;
		allhgtmin[i]=32767;
		allxoffmin[i]=32767;
		allyoffmin[i]=32767;
	}
	detailhdrdone=0;
	ntxtures=0;
	nwilds=0;
}

void FreeHist()
{
	free(DoMap);
	DoMap = NULL;
	free(txtures);
	txtures = NULL;
	free(wilds);
	wilds = NULL;
	free(txttotcnt);
	txttotcnt = NULL;
	free(txtuprcnt);
	txtuprcnt = NULL;
	free(txt1Sncnt);
	txt1Sncnt = NULL;
	free(txt2Sncnt);
	txt2Sncnt = NULL;
	free(txtlwrcnt);
	txtlwrcnt = NULL;
	free(txtlenmax);
	txtlenmax = NULL;
	free(txtlenmin);
	txtlenmin = NULL;
	free(txthgtmax);
	txthgtmax = NULL;
	free(txthgtmin);
	txthgtmin = NULL;
	free(txtxoffmax);
	txtxoffmax = NULL;
	free(txtxoffmin);
	txtxoffmin = NULL;
	free(txtyoffmax);
	txtyoffmax = NULL;
	free(txtyoffmin);
	txtyoffmin = NULL;
	free(alltotcnt);
	alltotcnt = NULL;
	free(alluprcnt);
	alluprcnt = NULL;
	free(all1Sncnt);
	all1Sncnt = NULL;
	free(all2Sncnt);
	all2Sncnt = NULL;
	free(alllwrcnt);
	alllwrcnt = NULL;
	free(alllenmax);
	alllenmax = NULL;
	free(alllenmin);
	alllenmin = NULL;
	free(allhgtmax);
	allhgtmax = NULL;
	free(allhgtmin);
	allhgtmin = NULL;
	free(allxoffmax);
	allxoffmax = NULL;
	free(allxoffmin);
	allxoffmin = NULL;
	free(allyoffmax);
	allyoffmax = NULL;
	free(allyoffmin);
	allyoffmin = NULL;
	free(ptchwid);
	ptchwid = NULL;
	free(ptchhgt);
	ptchhgt = NULL;
	free(ptchxo);
	ptchxo = NULL;
	free(ptchyo);
	ptchyo = NULL;
	free(lndf);
	lndf = NULL;
	detailhdrdone=0;
	ntxtures=0;
	nwilds=0;
}

static char *GetTxture(int n)
{
	static char theTexture[9];

	if (n<0 || n>=ntxtures) return "";
	strncpy(theTexture,txtures+8*n,8);
	theTexture[8]='\0';
	return theTexture;
}

static char *TxtureN(int n)
{
	static char theTexture[9];

	strncpy(theTexture,txtures+8*n,8);
	theTexture[8]='\0';
	return theTexture;
}

static char *GetWild(int n)
{
	static char theTexture[9];

	if (n<0 || n>=nwilds) return "";
	strncpy(theTexture,wilds+8*n,8);
	theTexture[8]='\0';
	return theTexture;
}

static int FindWild(char *theTexture)
{
	int i;

	for (i=0;i<nwilds;i++)
		if (strnicmp(theTexture,wilds+8*i,8)==0)
			return i;
	return -1;
}


static int BTFind(int strt,int end,char *theTexture)
{
	int mid;

	if (end-strt<2)
	{
		if (strnicmp(theTexture,txtures+8*strt,8)<=0)
			return strt;
		if (strnicmp(theTexture,txtures+8*end,8)<=0)
			return end;
		return end+1;
	}
	mid = (strt + end)/2;
	if (strnicmp(theTexture,txtures+8*mid,8)==0)
		return mid;
	if (strnicmp(theTexture,txtures+8*mid,8)<0)
		return BTFind(strt,mid,theTexture);
	else
		return BTFind(mid,end,theTexture);
	return 0;
}

static int BFindTxture(char *theTexture)
{
	if (ntxtures<=0) return 0;
	return BTFind(0,ntxtures-1,theTexture);
}

static int ExistTxture(char *theTexture,int *n)
{
	static char tbuff[9];

	strncpy(tbuff,theTexture,8);
	tbuff[8]='\0';
	if (ntxtures<=0)
	{
		*n = -1;
		return 0;
	}
	*n = BTFind(0,ntxtures-1,tbuff);
	if (*n<0 || *n>ntxtures-1) return 0;
	return (stricmp(GetTxture(*n),tbuff)==0)? 1 : 0;
}

static void PutWild(int n,char *aTexture)
{
	strncpy(wilds+8*n,aTexture,8);
}

static void AddTxture(char *aTexture)
{
	int i;

	if (*aTexture=='-') return;
	for (i=0;i<8 && aTexture[i];i++)
		aTexture[i]=toupper(aTexture[i]);

	if (ntxtures==0)
	{
		strncpy(txtures,aTexture,8);
		ntxtures++;
	}
	else
	{
		i = BFindTxture(aTexture);
		if (ntxtures>i && stricmp(aTexture,GetTxture(i))!=0)
		{
			memmove(txtures+8*i+8,txtures+8*i,(ntxtures-i)*8);
		 	strncpy(txtures+8*i,aTexture,8);
		 	ntxtures++;
		}
		else if (ntxtures==i)
		{
		 	strncpy(txtures+8*i,aTexture,8);
		 	ntxtures++;
		}
	}
}

static void AddWild(char *aTexture)
{
	int i;

	if (*aTexture=='-') return;
	for (i=0;i<8 && aTexture[i];i++)
		aTexture[i]=toupper(aTexture[i]);

	i = FindWild(aTexture);
	if (i<0)
	{
		PutWild(nwilds,aTexture);
		nwilds++;
	}
}

static int WildMatch(char *candidate)
{
	int i;

	if (!nwilds) return 1;
	for (i=0;i<nwilds;i++)
		if (match(GetWild(i),candidate))
			return 1;
	return 0;
}



static void PrintDetailHeader(char *levname)
{
	printf("\nTexture Details for %s\n",levname);
	printf("TEXTURE  Line#   Side# U12L  Wid   Hgt Xoff Yoff\n");
	printf("------------------------------------------------\n");
}

static void PrintSidedefDetail(int sideno,int lineno,char *levname)
{
	int TwoSided=0,idx;
	int vis,t;

	TwoSided = (Linedefs[lineno].sides[1]!=-1)? 1 : 0;

	if (ExistTxture(Sidedefs[sideno].utxt,&idx))
	{
		if (!detailhdrdone)
		{
			PrintDetailHeader(levname);
			detailhdrdone=1;
		}
		vis = uprhgt(sideno,lineno,&t);
		printf
		(
			"%-8s %5d  %5d   %2s %5d %1s%4d %4d %4d\n",
		    Str8(Sidedefs[sideno].utxt),
			lineno,
			sideno,
			TwoSided? " U" : "1U",
			linelen(lineno),
			!vis && t? "T" : "",
			vis>=0? vis : 0,
			Sidedefs[sideno].xoff,
			Sidedefs[sideno].yoff
		);
	}

	if (ExistTxture(Sidedefs[sideno].ntxt,&idx))
	{
		if (!detailhdrdone)
		{
			PrintDetailHeader(levname);
			detailhdrdone=1;
		}
		if (TwoSided)
		{
			vis = no2hgt(sideno,lineno,&t);
		}
		else
		{
			vis = no1hgt(sideno,lineno,&t);
		}
		printf
		(
			"%-8s %5d  %5d    %1s %5d %1s%4d %4d %4d\n",
			Str8(Sidedefs[sideno].ntxt),
			lineno,
			sideno,
			TwoSided? "2":"1",
			linelen(lineno),
			!vis && t? "T" : "",
			vis>=0? vis : 0,
			Sidedefs[sideno].xoff,
			Sidedefs[sideno].yoff
		);
	}

	if (ExistTxture(Sidedefs[sideno].ltxt,&idx))
	{
		if (!detailhdrdone)
		{
			PrintDetailHeader(levname);
			detailhdrdone=1;
		}
		vis = lwrhgt(sideno,lineno,&t);
		printf
		(
			"%-8s %5d  %5d   %2s %5d %1s%4d %4d %4d\n",
			Str8(Sidedefs[sideno].ltxt),
			lineno,
			sideno,
			TwoSided? " L" : "1L",
			linelen(lineno),
			!vis && t? "T" : "",
			vis>=0? vis : 0,
			Sidedefs[sideno].xoff,
			Sidedefs[sideno].yoff
		);
	}
}

//TEXTURE  Uc 1c 2c Lc MinW MaxW MinX MaxX MinY MaxY

static void PrintStatsHeader(char *levname,char *hdrname)
{
	printf("Texture %s for %s\n",hdrname,levname);
	printf("           Tot   Upr   1SN   2SN  Lwr MinW MaxW MinH MaxH MinX MaxX MinY MaxY\n");
	printf("-----------------------------------------------------------------------------\n");
}

static void PrintTextureStats(char *levname)
{
	int i;
	int hdrdone=0;

	if (DoSummary)
	{
		for (i=0;i<ntxtures;i++)
		{
			if (txtuprcnt[i]+txt1Sncnt[i]+txt2Sncnt[i]+txtlwrcnt[i])
			{
				if (!hdrdone)
				{
					printf("\n");
					PrintStatsHeader(levname,"Summary");
					hdrdone=1;
				}
				printf
				(
					"%-8s %5d %5d %5d %4d %4d %4d %4d %4d %4d %4d %4d %4d %4d\n",
			   		GetTxture(i),
					txttotcnt[i],
					txtuprcnt[i],
					txt1Sncnt[i],
					txt2Sncnt[i],
					txtlwrcnt[i],
			   		txtlenmin[i],
					txtlenmax[i],
			   		txthgtmin[i],
					txthgtmax[i],
					txtxoffmin[i],
					txtxoffmax[i],
			   		txtyoffmin[i],
					txtyoffmax[i]
				);
			}
			else if (DoBlanks)
			{
				if (!hdrdone)
				{
					printf("\n");
					PrintStatsHeader(levname,"Summary");
					hdrdone=1;
				}
				printf
				(
					"%-8s %5d %5d %5d %4d %4d ---- ---- ---- ---- ---- ---- ---- ----\n",
			   		GetTxture(i),
					txttotcnt[i],
					txtuprcnt[i],
					txt1Sncnt[i],
					txt2Sncnt[i],
					txtlwrcnt[i]
				);
			}
		}
		if (DoBlanks && !hdrdone)
		{
			printf("\n");
			PrintStatsHeader(levname,"Summary");
			printf("No occurrences of selected textures in this level\n");
		}
		if (hdrdone) printf("\n");
	}
}

static void PrintAllStats()
{
	int i;
	int hdrdone=0;

	if (DoTotals)
	{
		for (i=0;i<ntxtures;i++)
		{
			if (alluprcnt[i]+all1Sncnt[i]+all2Sncnt[i]+alllwrcnt[i])
			{
				if (!hdrdone)
				{
					printf("\n------------------------------------------------------------------------------\n");
					PrintStatsHeader("all levels","TOTALS");
					hdrdone=1;
				}
				printf("%-8s %5d %5d %5d %4d %4d %4d %4d %4d %4d %4d %4d %4d %4d\n",
			   		GetTxture(i),alltotcnt[i],alluprcnt[i],all1Sncnt[i],all2Sncnt[i],alllwrcnt[i],
			   		alllenmin[i],alllenmax[i],allhgtmin[i],allhgtmax[i],allxoffmin[i],allxoffmax[i],
			   		allyoffmin[i],allyoffmax[i]);
			}
			else if (DoBlanks)
			{
				if (!hdrdone)
				{
					printf("\n------------------------------------------------------------------------------\n");
					PrintStatsHeader("all levels","TOTALS");
					hdrdone=1;
				}
				printf("%-8s %5d %5d %5d %4d %4d ---- ---- ---- ---- ---- ---- ---- ----\n",
			   		GetTxture(i),alltotcnt[i],alluprcnt[i],all1Sncnt[i],all2Sncnt[i],alllwrcnt[i]);
			}
		}
		if (DoBlanks && !hdrdone)
		{
			printf("\n------------------------------------------------------------------------------\n");
			PrintStatsHeader("all levels","TOTALS");
			printf("No occurrences of textures in any level\n");
		}

	}
}

static void AccumulateTextureStats(int sideno,int lineno)
{
	int TwoSided=0;
	int l,n,t;

	TwoSided = (Linedefs[lineno].sides[1]!=-1)? 1 : 0;
	if (strncmp("-",Sidedefs[sideno].utxt,1) &&
					ExistTxture(Sidedefs[sideno].utxt,&n))
	{
		txtuprcnt[n]++;
		txttotcnt[n]++;
		l = linelen(lineno);
		if (l<txtlenmin[n])
			txtlenmin[n]=l;
		if (l>txtlenmax[n])
			txtlenmax[n]=l;
		l = uprhgt(sideno,lineno,&t);
		if (l<txthgtmin[n])
			txthgtmin[n]=l;
		if (l>txthgtmax[n])
			txthgtmax[n]=l;
		l = Sidedefs[sideno].xoff;
		if (l<txtxoffmin[n])
			txtxoffmin[n]=l;
		if (l>txtxoffmax[n])
			txtxoffmax[n]=l;
		l = Sidedefs[sideno].yoff;
		if (l<txtyoffmin[n])
			txtyoffmin[n]=l;
		if (l>txtyoffmax[n])
			txtyoffmax[n]=l;
	}

	if (strncmp("-",Sidedefs[sideno].ntxt,1) &&
		            ExistTxture(Sidedefs[sideno].ntxt,&n))
	{
		txttotcnt[n]++;
		if (TwoSided)
		{
			txt2Sncnt[n]++;
			l = no2hgt(sideno,lineno,&t);
		}
		else
		{
			l = no1hgt(sideno,lineno,&t);
			txt1Sncnt[n]++;
		}
		if (l<txthgtmin[n])
			txthgtmin[n]=l;
		if (l>txthgtmax[n])
			txthgtmax[n]=l;
		l = linelen(lineno);
		if (l<txtlenmin[n])
			txtlenmin[n]=l;
		if (l>txtlenmax[n])
			txtlenmax[n]=l;
		l = Sidedefs[sideno].xoff;
		if (l<txtxoffmin[n])
			txtxoffmin[n]=l;
		if (l>txtxoffmax[n])
			txtxoffmax[n]=l;
		l = Sidedefs[sideno].yoff;
		if (l<txtyoffmin[n])
			txtyoffmin[n]=l;
		if (l>txtyoffmax[n])
			txtyoffmax[n]=l;
	}
	if (strncmp("-",Sidedefs[sideno].ltxt,1) &&
					ExistTxture(Sidedefs[sideno].ltxt,&n))
	{
		txtlwrcnt[n]++;
		txttotcnt[n]++;
		l = linelen(lineno);
		if (l<txtlenmin[n])
			txtlenmin[n]=l;
		if (l>txtlenmax[n])
			txtlenmax[n]=l;
		l = lwrhgt(sideno,lineno,&t);
		if (l<txthgtmin[n])
			txthgtmin[n]=l;
		if (l>txthgtmax[n])
			txthgtmax[n]=l;
		l = Sidedefs[sideno].xoff;
		if (l<txtxoffmin[n])
			txtxoffmin[n]=l;
		if (l>txtxoffmax[n])
			txtxoffmax[n]=l;
		l = Sidedefs[sideno].yoff;
		if (l<txtyoffmin[n])
			txtyoffmin[n]=l;
		if (l>txtyoffmax[n])
			txtyoffmax[n]=l;
	}
}

static void MakeSide2Line(void)
{
	int i,s1,s2;

	for (i=0;i<NSidedefs;i++)
	    lndf[i] = -1;
	for (i=0;i<NLinedefs;i++)
	{
		s1 = Linedefs[i].sides[0];
		s2 = Linedefs[i].sides[1];
		if (s1>=0 && s1<NSidedefs)
			lndf[s1]=i;
		if (s2>=0 && s2<NSidedefs)
			lndf[s2]=i;
	}
}

static void ScanResourceWads(char **rwads,int nrwads,VTex **patchlist,int *npatches)
{
	int k,c,j;
	WadDir pdir;
	WadTextures *pwt;
	SwitchData *swbuffer=NULL;
	AnimData *animbuffer=NULL;

	pwt = malloc (nrwads*sizeof(WadTextures));

	for (k=0;k<nrwads;k++)
	{
		if (stricmp(rwads[k],bwadname)==0)
			pst = bst;
		else
			pst = fopen(rwads[k],"rb");

		if (pst)
		{
			dprintf(logfile,"Scanning resource wad %s\n",rwads[k]);

			InitDir(&pdir);
			fseek(pst,0,SEEK_SET);
			fread(&phdr,sizeof(WadHeader),1,pst);
			ReadDir(&phdr,&pdir,pst);

			FreeResourceDefinition(&pResDef);
			LocateCategories(&pdir,&ResDef,&pResDef);

			{
				int hastextures = IsIn("PNAMES",&pdir)>=0 && IsIn("TEXTURE1",&pdir)>=0;

				InitTextures(pwt+k);
				if (hastextures)
				{
					ReadPNames(&pdir,pst,pwt+k);
					ReadTextures(&pdir,pst,pwt+k);
				}

				// list the patches in the resource wad
				c = CategoryOf("PATCHES",&pResDef);
				if (c>=0)
					for (j=0;j<pResDef.cat[c].nnames;j++)
						AddNewVTex(patchlist,npatches,1,pResDef.cat[c].Names[j].str,NULL,NULL,0,NULL);

				// if a SWITCHES lump exists, read it, replacing any already read
				if (DoSwitches)
				{
					int b = IsIn("SWITCHES",&pdir);

					if (b>=0)
					{
						int n=pdir.dirp[b].reslen;
						int o=pdir.dirp[b].resptr;

						swbuffer = realloc(swbuffer,n);

						fseek(pst,o,SEEK_SET);
						fread(swbuffer,n,1,pst);
					}	
				}

				// if an ANIMATED lump exists, read it, replacing any already read
				if (DoAnimated)
				{
					int b=IsIn("ANIMATED",&pdir);

					if (b>=0)
					{
						int n=pdir.dirp[b].reslen;
						int o=pdir.dirp[b].resptr;

						animbuffer = realloc(animbuffer,n);

						fseek(pst,o,SEEK_SET);
						fread(animbuffer,n,1,pst);
					}
				}

				FreeResourceDefinition(&pResDef);
			}

			if (pst!=bst)
			{
				fclose(pst);
				pst=NULL;
			}
			FreeDir(&pdir);
		}
		else dprintf(logfile,"Can't open %s for texture resolution\n",rwads[k]);
	}

	// add the starting and ending name of each switch in the last SWITCHES
	if (DoSwitches)
	{
		int i;

		if (swbuffer)
			for (i=0;swbuffer[i].episode;i++)
			{
				AddTxture(swbuffer[i].name1);
				AddTxture(swbuffer[i].name2);
			}
		else // no SWITCHES lump use list of all DOOM/DOOM2 switches
			for (i=0;i<nswitchnames;i++)
				AddTxture(switchnames[i]);
	}

	// add the starting and ending name of each animation in the last ANIMATED
	// if they can be found, also add the intermediate names
	if (DoAnimated)
	{
		int i;

		if (animbuffer)
			for (i=0;animbuffer[i].istexture!=-1;i++)
			{
				if (animbuffer[i].istexture==1)
				{
					int j,s=-1,e=-1;
					int hastextures = IsIn("PNAMES",&pdir)>=0 && IsIn("TEXTURE1",&pdir)>=0;

					// check both start and end present, end > start
					// use definition in last loaded wad that contains both
					for (k=nrwads-1;hastextures && k>=0;k--)
					{
						s = FindTexture(&pwt[k].t1,animbuffer[i].startname);
						e = FindTexture(&pwt[k].t1,animbuffer[i].endname);

						if (s>=0 && e>=0 && e>=s)
							break;
					}

					if (s>=0 && e>=0 && e>=s) // add all animation textures
					{
						for (j=s;j<=e;j++)
							AddTxture(pwt[k].t1.textures[j].textname);
					}
					else											// add just start and end, warn
					{
						dprintf(logfile,"Warning: Intermediate frames for %s-%s not known\n",animbuffer[i].startname,animbuffer[i].endname);
						AddTxture(animbuffer[i].startname);
						AddTxture(animbuffer[i].endname);
					}
				}
			}
		else // no ANIMATED lump, add all DOOM/DOOM II wall animations
			for (i=0;i<nanimnames;i++)
				AddTxture(animnames[i]);
	}
	for (k=0;k<nrwads;k++)
		FreeTextures(pwt+k);
}

static int CheckResourceWads(char **rwads,int nrwads,char ***plists,int *nplist,int *tmiss)
{
	int k;

	for (k=0;k<nrwads;k++)
	{
		if (stricmp(rwads[k],bwadname)==0)
			pst = bst;
		else
			pst = fopen(rwads[k],"rb");

		if (pst)
		{
			dprintf(logfile,"Checking resource wad %s\n",rwads[k]);

			fseek(pst,0,SEEK_SET);
			fread(&phdr,sizeof(WadHeader),1,pst);
			ReadDir(&phdr,&pdir,pst);

			{
				int hastextures = IsIn("PNAMES",&pdir)>=0 && IsIn("TEXTURE1",&pdir)>=0;
				int i;

				if (hastextures)
				{
					ReadPNames(&pdir,pst,&pwt);
					ReadTextures(&pdir,pst,&pwt);
				}
				for (i=0;i<ntxtures;i++)
				{
					int t,j;

					if (IsColTranMap(GetTxture(i),&pdir,&ResDef))
 					  tmiss[i]++;
					if (hastextures && (t=FindTexture(&pwt.t1,GetTxture(i)))>=0)
					{
 					  tmiss[i]++;
						FreeDynStr(plists+i,nplist+i);
						for (j=0;j<pwt.t1.textures[t].npatches;j++)
							AddDynStr(plists+i,nplist+i,GetPName(&pwt.pnames,pwt.t1.textures[t].patches[j].pidx));
					}
				}
				if (hastextures) FreeTextures(&pwt);
			}

			if (pst!=bst)
			{
				fclose(pst);
				pst=NULL;
			}
			FreeDir(&pdir);
		}
	}
	return 0;
}

int txtumain(int argc,char **argv)
{
	int m,n,i,j,k,l;
	int cleared=0,nlevs=0;
	int *tmiss=NULL;
	char levname[16],*q;
	char **rwads=NULL;
	char ***plists=NULL;
	int *nplist=NULL;
	int nrwads=0;
	int missing=0,pmissing=0;
	char subsname[16]="";

	dprintf(logfile,"\n");

	CopyEnvironmentCLArgs("TXTUSE",argc,argv);
	if (ParseCommandLine(-1,-1))
	{
		FreeCLStrs();
		return 3;
	}

	if (nclfiles<1)
	{
 		dprintf(logfile,"\nTXTUSE.EXE by Jim Flynn, Copyright 1997-8 %s -- Freeware --\n\n",PATCHER_VERSION);
		dprintf(logfile,"Analyze the levels in a wad for texture usage. Can work on all\n");
		dprintf(logfile,"textures in all levels, or on specified textures in specified levels\n");
		dprintf(logfile,"\nUsage: TXTUSE [options] levels[.wad] [MAPnn[-mm]]... [TEXTURE]...\n");
		dprintf(logfile,"TEXTURE may contain wildcards *, ?, #, or be SWITCHES or ANIMATIONS\n");
		dprintf(logfile,"\nOutput selection option (default is to do all):\n");
		dprintf(logfile," +XY does only X, Y outputs, -XY does all BUT X, Y outputs.\n");
		dprintf(logfile,"  D DETAILS    S SUMMARY    T TOTALS\n");
		dprintf(logfile,"\nUse /R[:resource[.wad]]... to check missing textures or patches\n");
		dprintf(logfile,"Use /W[:resource[.wad]]... to load needed resources and analyze textures\n");
		dprintf(logfile,"Use /U to show unused textures in summary or totals\n");
		dprintf(logfile,"Use /I to scan internal textures from PNAMES and TEXTURE1 in levels.wad\n");
		dprintf(logfile,"Use /M[:textname] to substitute all missing textures with textname[-]\n");
		dprintf(logfile,"Use /C to clear all upper and lower textures from one-sided sidedefs\n");
    dprintf(logfile,"See TXTUSE.TXT for details\n");
		FreeCLStrs();
		return 1;
	}

	DoBlanks=0;
	cleared = 0;
	for (i=0;i<nclopts;i++)
	{
		n = strspn(cloptions[i],"dstDST");
		if (n==strlen(cloptions[i]))
		{
			if (!cleared)	// if first selection option
			{
				if (cloptsense[i])	// clear all if it adds types
					DoDetails=DoSummary=DoTotals=0;
				else if (!cloptsense[i]) // set all if it subtracts types
					DoDetails=DoSummary=DoTotals=1;
				cleared=1;	// but don't do it for following selection opts
			}
			for (j=0;j<strlen(cloptions[i]);j++)
			{
				switch(tolower(cloptions[i][j]))
				{
					case 'd':
						DoDetails = cloptsense[i];
						break;
					case 's':
						DoSummary = cloptsense[i];
						break;
					case 't':
						DoTotals = cloptsense[i];
						break;
				}
			}
		}
		else if (tolower(cloptions[i][0])=='m')
		{
			strcpy(subsname,"-");
			if (cloptions[i][1]==':')
				strcpy(subsname,cloptions[i]+2);
		}
		else if (tolower(cloptions[i][0])=='r')
		{
			strcpy(pwadname,"");
			if (cloptions[i][1]==':')
				strcpy(pwadname,cloptions[i]+2);
			AddExt(pwadname,".WAD");
			if (*pwadname)
				AddDynStr(&rwads,&nrwads,pwadname);
			else if (nclfiles>0)
			{
				strcpy(pwadname,clfiles[0]);
				AddExt(pwadname,".WAD");
				AddDynStr(&rwads,&nrwads,pwadname);
			}
			ResolveTextures=1;
		}
		else if (tolower(cloptions[i][0])=='w')
		{
			strcpy(pwadname,"");
			if (cloptions[i][1]==':')
				strcpy(pwadname,cloptions[i]+2);
			AddExt(pwadname,".WAD");
			if (*pwadname)
				AddDynStr(&rwads,&nrwads,pwadname);
			else if (nclfiles>0)
			{
				strcpy(pwadname,clfiles[0]);
				AddExt(pwadname,".WAD");
				AddDynStr(&rwads,&nrwads,pwadname);
			}
		}
		else if (tolower(cloptions[i][0])=='u')
			DoBlanks=cloptsense[i];
		else if (tolower(cloptions[i][0])=='i')
			UseInternalTextures=cloptsense[i];
		else if (tolower(cloptions[i][0])=='c')
			Clear1SUL = cloptsense[i];
		else dprintf(logfile,"Warn: command line option: %s not understood\n",cloptions[i]);
	}

	InitVTex();
	AllocHist();

	AddExt(defname,".DEF");
	InitCategories(defname,&ResDef);

	strcpy(bwadname,clfiles[0]);

	for (i=1;i<=32;i++)
		DoMap[i] = 1;
	for (i=1;i<nclfiles;i++)
		if (strnicmp("MAP",clfiles[i],3)==0)
		{
			q = strchr(clfiles[i],'-');			// check for range: Map1-13
			if (q) *q='\0';
			if (NumsOnly(clfiles[i]+3))			// insure range is numeric
				if (!q || NumsOnly(q+1))
				{
					if (!cleared)
						for (j=1;j<=32;j++)				// if maps specified do those given
							DoMap[j] = 0;						// otherwise default to do all
					cleared=1;

					n = atoi(clfiles[i]+3);			// get map number
					m = q? atoi(q+1) : n;

					for	(j=n;j<=m;j++)
						if (1<=j && j<=32)
							DoMap[j]=1;							// if in range, add it to list
						else
							dprintf(logfile,"WARNING: %s not a valid Map for DOOM II\n",clfiles[i]);
				}
		}
		else if (stricmp(clfiles[i],"ANIMATIONS")==0)
			DoAnimated=1;
		else if (stricmp(clfiles[i],"SWITCHES")==0)
			DoSwitches=1;
		else
		{
			if (strcspn(clfiles[i],"*#?")!=strlen(clfiles[i]))
				AddWild(clfiles[i]);	// texture name with wild char
			else
			{
				AddTxture(clfiles[i]);	// pure texture name
				DoSingles++;
			}
		}

	FreeCLStrs();

	AddExt(bwadname,".WAD");
	if (*subsname || Clear1SUL)
		bst = fopen(bwadname,"r+b");
	else
		bst = fopen(bwadname,"rb");
	if (bst!=NULL)
	{
		int b;

		fread(&bhdr,sizeof(WadHeader),1,bst);
		ReadDir(&bhdr,&bdir,bst);

		if (Clear1SUL)
		{
			dprintf(logfile,"Info: Clearing all one-sided upper and lower textures\n");
			for (k=1;k<32;k++)
			{
				if (DoMap[k])
				{
					int b = IsIn(stringf("MAP%02d",k),&bdir);
					int c = IsAfter(b,"SIDEDEFS",&bdir);
					int d = IsAfter(b,"LINEDEFS",&bdir);
					if (c>=0 && c<b+11 && d>=0 && d<b+11)
					{
						fseek(bst,bdir.dirp[c].resptr,SEEK_SET);
						Sidedefs = realloc(Sidedefs,bdir.dirp[c].reslen);
						fread(Sidedefs,bdir.dirp[c].reslen,1,bst);
						NSidedefs = bdir.dirp[c].reslen/sizeof(Sidedef);
						fseek(bst,bdir.dirp[d].resptr,SEEK_SET);
						Linedefs = realloc(Linedefs,bdir.dirp[d].reslen);
						fread(Linedefs,bdir.dirp[d].reslen,1,bst);
						NLinedefs = bdir.dirp[d].reslen/sizeof(Linedef);

						for (i=0;i<NLinedefs;i++)
						{
							if (Linedefs[i].sides[1]==-1)
							{
								int s = Linedefs[i].sides[0];
								strncpy(Sidedefs[s].utxt,"-",8);
								strncpy(Sidedefs[s].ltxt,"-",8);
							}
						}
						fseek(bst,bdir.dirp[c].resptr,SEEK_SET);
						fwrite(Sidedefs,bdir.dirp[c].reslen,1,bst);
					}
				}
			}
		}
		ScanResourceWads(rwads,nrwads,&mtxres[0],&mtxcnt[0]);

		if (UseInternalTextures)
		{
			if (IsIn("TEXTURE1",&bdir) && IsIn("PNAMES",&bdir))
			{
				ReadPNames(&bdir,bst,&bwt);
				ReadTextures(&bdir,bst,&bwt);
				for (i=0;i<bwt.t1.N;i++)
					if (WildMatch(bwt.t1.textures[i].textname))
						AddTxture(bwt.t1.textures[i].textname);
			}
			else dprintf(logfile,"\nWARNING: Couldnt use internal textures, TEXTURE1 or PNAMES not found\n");
		}

		if (ntxtures==0 || nwilds)	// if no textures specified or added
		{							 							// add all textures occurring in all levels
			nlevs=0;									// also match if wild textures specified
			for (i=1;i<=32;i++)
				if (DoMap[i])
				{
					sprintf(levname,"MAP%02d",i);
					b = IsIn(levname,&bdir);
					if (b>=0)
					{
						ReadLevelData(levname,&bdir,bst,NLevObj());
						dprintf(logfile,"Adding textures in %s\n",levname);
						for (j=0;j<NSidedefs;j++)
						{
							if (WildMatch(Str8(Sidedefs[j].utxt)))
								AddTxture(Str8(Sidedefs[j].utxt));
							if (WildMatch(Str8(Sidedefs[j].ntxt)))
								AddTxture(Str8(Sidedefs[j].ntxt));
							if (WildMatch(Str8(Sidedefs[j].ltxt)))
								AddTxture(Str8(Sidedefs[j].ltxt));
						}
						FreeLevelData();
						nlevs++;
					}
				}
			if (nlevs) dprintf(logfile,"\n");
		}

		if (ResolveTextures)
		{
			tmiss = malloc(ntxtures*sizeof(int));
			memset(tmiss,0,ntxtures*sizeof(int));
			plists = malloc(ntxtures*sizeof(char **));
			memset(plists,0,ntxtures*sizeof(char **));
			nplist = malloc(ntxtures*sizeof(int));
			memset(nplist,0,ntxtures*sizeof(int));

			CheckResourceWads(rwads,nrwads,plists,nplist,tmiss);

			for (k=0;k<ntxtures;k++)
			{
				if (!tmiss[k])
				{
					dprintf(logfile,"ERROR: Missing texture %s in resource wads\n",GetTxture(k));
					missing=1;
				}
				for (j=0;j<nplist[k];j++)
					if (IsInVTex(plists[k][j],mtxres[0],mtxcnt[0])<0)
					{
						dprintf(logfile,"ERROR: Patch %s used by texture %s missing in resource wads\n",plists[k][j],GetTxture(k));
						pmissing=1;
					}
			}
			if (missing)
			{
				if (*subsname)
				{
					dprintf(logfile,"Info: Replacing missing textures with %s\n",subsname);
					for (k=1;k<32;k++)
					{
						if (DoMap[k])
						{
							int b = IsIn(stringf("MAP%02d",k),&bdir);
							int c = IsAfter(b,"SIDEDEFS",&bdir);
							if (c<b+11)
							{
								fseek(bst,bdir.dirp[c].resptr,SEEK_SET);
								Sidedefs = realloc(Sidedefs,bdir.dirp[c].reslen);
								fread(Sidedefs,bdir.dirp[c].reslen,1,bst);
								NSidedefs = bdir.dirp[c].reslen/sizeof(Sidedef);

								for (i=0;i<NSidedefs;i++)
								{
									for (j=0;j<ntxtures;j++)
										if (!tmiss[j])
										{
											if (stricmp(Str8(Sidedefs[i].utxt),GetTxture(j))==0)
												strncpy(Sidedefs[i].utxt,subsname,8);
											if (stricmp(Str8(Sidedefs[i].ntxt),GetTxture(j))==0)
												strncpy(Sidedefs[i].ntxt,subsname,8);
											if (stricmp(Str8(Sidedefs[i].ltxt),GetTxture(j))==0)
												strncpy(Sidedefs[i].ltxt,subsname,8);
										}

								}
								fseek(bst,bdir.dirp[c].resptr,SEEK_SET);
								fwrite(Sidedefs,bdir.dirp[c].reslen,1,bst);
							}
						}
					}
					ntxtures=0;
					AddTxture(subsname);
					dprintf(logfile,"Info: Analyzing substituted texture: %s only\n",subsname);
				}
				else
				{
					int n=ntxtures;
					dprintf(logfile,"Info: Analyzing missing textures only\n");
					ntxtures=0;
					for (k=0;k<n;k++)
						if (!tmiss[k])
							AddTxture(TxtureN(k));
				}
			}
			else
			{
				ntxtures=0;
				dprintf(logfile,"\nInfo: No textures in levels missing in resource wads\n");
				if (!pmissing)
					dprintf(logfile,"Info: No patches used by textures in levels missing in resource wads\n");
				dprintf(logfile,"\n");
			}
			free(tmiss);
			for (i=0;i<ntxtures;i++)
				FreeDynStr(&plists[i],&nplist[i]);
			free(plists);
			free(nplist);
			FreeVTex();
		}

		nlevs=0;
		dprintf(logfile,"\n");
		for (i=1;i<=32;i++)
		{
			if (DoMap[i])
			{
				detailhdrdone=0;
				sprintf(levname,"MAP%02d",i);
				b = IsIn(levname,&bdir);
				if (b>=0)
				{
					if (ntxtures)
					{
						dprintf(logfile,"Analyzing textures in %s\n",levname);

						InitMapHist();
						ReadLevelData(levname,&bdir,bst,NLevObj());

						MakeSide2Line();
						for (j=0;j<NSidedefs;j++)
						{
							l = lndf[j];
							if (l>=0)
							{
								if (DoDetails)
									PrintSidedefDetail(j,l,levname);
								AccumulateTextureStats(j,l);
							}
						}

						PrintTextureStats(levname);
						for (j=0;j<ntxtures;j++)
						{
							alluprcnt[j] += txtuprcnt[j];
							all1Sncnt[j] += txt1Sncnt[j];
							all2Sncnt[j] += txt2Sncnt[j];
							alllwrcnt[j] += txtlwrcnt[j];
							alltotcnt[j] += txttotcnt[j];
							if (txtlenmax[j]>alllenmax[j])
								alllenmax[j]=txtlenmax[j];
							if (txthgtmax[j]>allhgtmax[j])
								allhgtmax[j]=txthgtmax[j];
							if (txtxoffmax[j]>allxoffmax[j])
								allxoffmax[j]=txtxoffmax[j];
							if (txtyoffmax[j]>allyoffmax[j])
								allyoffmax[j]=txtyoffmax[j];
							if (txtlenmin[j]<alllenmin[j])
								alllenmin[j]=txtlenmin[j];
							if (txthgtmin[j]<allhgtmin[j])
								allhgtmin[j]=txthgtmin[j];
							if (txtxoffmin[j]<allxoffmin[j])
								allxoffmin[j]=txtxoffmin[j];
							if (txtyoffmin[j]<allyoffmin[j])
								allyoffmin[j]=txtyoffmin[j];
						}
						nlevs++;
						FreeLevelData();
					}
				}
			}
		}

		if (ntxtures && !nlevs)
			dprintf(logfile,"No maps found to analyze usage in\n");
		if (nlevs) dprintf(logfile,"\n");
		if (nlevs>1) PrintAllStats();

	}
	else dprintf(logfile,"Cant open %s for read\n",bwadname);

	return 0;
}
